import { __assign } from "tslib";
import sdk from '@tcwd/weapps-sdk/lib/app-h5-sdk';
import { createWebApp, _ACTIONS_KEY as ACTIONS_KEY, _ROUTER_KEY as ROUTER_KEY, } from '@cloudbase/weda-client';
import { runtime } from '../utils/adapter/index';
import { getEnumOptions } from '../utils/initGlobalVar';
import { get as lodashGet } from 'lodash-es';
import { OFFICIAL_LIB_KEY } from '@cloudbase/cals';
import { observable } from 'mobx';
var EPLATFORM;
(function (EPLATFORM) {
    EPLATFORM["WEB"] = "WEB";
    /**
     * 拼写错误
     * 兼容性无法修改
     */
    EPLATFORM["MINIPROGRAM"] = "MINIPROGRAME";
})(EPLATFORM || (EPLATFORM = {}));
var DEFAULT_INIT_DATA = {
    processAction: function (key, action) {
        switch (key) {
            case ACTIONS_KEY.showModal: {
                return function (obj) {
                    var _a, _b, _c;
                    var showModal = (_b = (_a = runtime["@weapps-materials-main-".concat(OFFICIAL_LIB_KEY)]) === null || _a === void 0 ? void 0 : _a.actions) === null || _b === void 0 ? void 0 : _b.showModal;
                    var isMobile = (_c = app === null || app === void 0 ? void 0 : app.__internal__) === null || _c === void 0 ? void 0 : _c.isMobile;
                    if (isMobile && !isMobile() && showModal) {
                        return showModal({ data: obj, _origin: action });
                    }
                    return action(obj);
                };
            }
            case ACTIONS_KEY.showToast: {
                return function (obj) {
                    var _a, _b;
                    var showMessage = (_b = (_a = runtime["@weapps-materials-main-".concat(OFFICIAL_LIB_KEY)]) === null || _a === void 0 ? void 0 : _a.actions) === null || _b === void 0 ? void 0 : _b.showMessage;
                    if (showMessage) {
                        return showMessage({ data: obj, _origin: action });
                    }
                    return action(obj);
                };
            }
        }
        return action;
    },
};
export var subPackageName = '';
export var app = createGlboalApi(DEFAULT_INIT_DATA);
export var $w = new Proxy(app.__internal__.$w, {
    get: function (_, prop) {
        var _a;
        return (_a = app.__internal__.$w) === null || _a === void 0 ? void 0 : _a[prop];
    },
});
export function registerApp(_app) {
    if (_app === void 0) { _app = createGlboalApi(DEFAULT_INIT_DATA); }
    _injectApp2Runtime(_app, true);
    app = _app;
}
mountAPIs(sdk);
function createGlboalApi(initData) {
    if (initData === void 0) { initData = {}; }
    var webApp = createWebApp(initData);
    var globalAPI = new Proxy(Object.assign(webApp, __assign(__assign({ domain: initData.domain || '', state: {}, computed: {}, dataset: {}, common: {}, enumOptions: {} }, webApp), { utils: __assign(__assign({}, webApp.utils), { formatEnum: function (path, optionname, app) {
                var _a, _b, _c;
                var isSingle = Array.isArray(path);
                // 这个app是后来添加进去的
                var options = app === null || app === void 0 ? void 0 : app.enumOptions;
                var parseOptions = options[optionname] ? options[optionname] : getEnumOptions(optionname);
                if (parseOptions === '') {
                    return !isSingle ? path : path.join(',');
                }
                var multiTmp = [];
                var value = !isSingle
                    ? (_b = (_a = JSON.parse(parseOptions)) === null || _a === void 0 ? void 0 : _a.find(function (item) { return item.key === path; })) === null || _b === void 0 ? void 0 : _b.value
                    : (_c = JSON.parse(parseOptions)) === null || _c === void 0 ? void 0 : _c.filter(function (item) { return path.some(function (pathValue) { return item.key === pathValue; }); }).map(function (item) { return multiTmp.push(item.value); });
                return !isSingle ? value : multiTmp.join(',');
            } }), 
        /**
         * setState
         */
        setState: function (userSetState) {
            Object.keys(userSetState).forEach(function (keyPath) {
                globalAPI.utils.set(globalAPI.dataset.state, keyPath, userSetState[keyPath]);
            });
        }, invoke: function (params) {
            var $page = globalAPI.utils.getCurrentPage();
            return $page.invokeComponentMethod(params);
        } })), {
        get: function (obj, prop) {
            if (prop === 'app' || prop === '$app') {
                return app;
            }
            else {
                return obj[prop];
            }
        },
        // set: (obj, prop, value) => {
        //   if (prop === 'app' || prop === '$app') {
        //     console.warn('$app 对象中 app/$app 为只读');
        //     return false;
        //   } else {
        //     // 修改 obj
        //     return true;
        //   }
        // },
    });
    _injectApp2Runtime(globalAPI);
    return globalAPI;
}
function _injectApp2Runtime(globalAPI, hard) {
    var _a;
    if (hard === void 0) { hard = false; }
    // 给全局挂上 mainApp/subApp
    // The global api exposed to lowcode
    if (subPackageName) {
        globalAPI.mainApp = runtime.$app;
        runtime["$$subapp_".concat(subPackageName)] = globalAPI;
    }
    else {
        // 预览区调试栏可调试
        // 暴露给复合组件，代码组件来引用
        runtime.app = hard ? globalAPI : runtime.app || globalAPI;
        runtime.$app = new Proxy(runtime.app, {
            get: function (obj, prop) {
                return obj ? obj[prop] : undefined;
            },
            set: function (obj, prop, value) {
                if (obj) {
                    return (obj[prop] = value);
                }
                else {
                    return undefined;
                }
            },
        });
        runtime.$w = new Proxy($w || ((_a = globalAPI === null || globalAPI === void 0 ? void 0 : globalAPI.__internal__) === null || _a === void 0 ? void 0 : _a.$w) || {}, {
            get: function (_, prop) {
                var _a, _b, _c, _d, _e, _f;
                var $page = ((_b = (_a = runtime.app) === null || _a === void 0 ? void 0 : _a.__internal__) === null || _b === void 0 ? void 0 : _b.activePage) || runtime.$page;
                if ((_d = (_c = $page === null || $page === void 0 ? void 0 : $page.__internal__) === null || _c === void 0 ? void 0 : _c.$w) === null || _d === void 0 ? void 0 : _d[prop]) {
                    return (_f = (_e = $page === null || $page === void 0 ? void 0 : $page.__internal__) === null || _e === void 0 ? void 0 : _e.$w) === null || _f === void 0 ? void 0 : _f[prop];
                }
                /**
                 * 此处应该统一到 $page 的生成上
                 * 但是有可能有受控 $page 注入的情况
                 * 理想应该在注入的入口完成，如果有遗漏的话，打开这里来兜底
                 */
                // let pageWidget = lodashGet($page, `widgets.${prop}`);
                // if (pageWidget) {
                //   return pageWidget._userWidget;
                // }
                return null;
            },
        });
    }
}
export function removeGlboalApi() {
    if (subPackageName) {
        runtime["$$subapp_".concat(subPackageName)] = undefined;
    }
    else {
        runtime.app = undefined;
        runtime.$app = undefined;
    }
}
export function createPageApi() {
    var $page = new Proxy({
        __internal__: {},
        state: {},
        computed: {},
        handler: {},
        props: {},
        widgets: observable({}),
        dataset: {},
        setState: function (userSetState) {
            Object.keys(userSetState).forEach(function (keyPath) {
                var _a;
                app.utils.set((_a = $page.dataset) === null || _a === void 0 ? void 0 : _a.state, keyPath, userSetState[keyPath]);
            });
        },
        _dataBinds: {},
        invokeComponentMethod: function (_a) {
            var _b, _c;
            var component = _a.component, method = _a.method, params = _a.params;
            var widgetData = lodashGet($page.widgets, component);
            if (Array.isArray(widgetData)) {
                throw new Error("\u8C03\u7528\u65B9\u6CD5\u5931\u8D25\uFF1Aid\u4E3A".concat(component, "\u7684\u7EC4\u4EF6\u62E5\u6709\u591A\u4E2A\u5B9E\u4F8B"));
                // widgetData.forEach(widget => {
                //   if(!widget._methods[method]) {
                //     throw new Error('NOT_FOUND')
                //   } else {
                //     actions.push(widget._methods[method])
                //   }
                // })
            }
            else {
                var action = (_c = (_b = widgetData === null || widgetData === void 0 ? void 0 : widgetData._userWidget) === null || _b === void 0 ? void 0 : _b.custom) === null || _c === void 0 ? void 0 : _c[method];
                if (typeof action !== 'function') {
                    throw new Error("\u8C03\u7528\u65B9\u6CD5\u5931\u8D25\uFF1A\u672A\u627E\u5230id\u4E3A".concat(component, "\u4E0B\u7684\u65B9\u6CD5").concat(method));
                }
                return action(params);
            }
        },
    }, {
        get: function (obj, prop) {
            return prop === '$page' ? obj : obj[prop];
        },
    });
    return $page;
}
// 分app 和 wx 挂载app
function mountAPIs(sdks) {
    Object.keys(sdks).forEach(function (item) {
        var action = sdks[item];
        if (!(item in ACTIONS_KEY) && !(item in ROUTER_KEY)) {
            app[item] = action;
        }
    });
    return app;
}
