import { IAppAPI, IPageAPI } from '../app/global-api';
export declare function initAppLifeCycle(app: any, appLifeCycle: any, force?: boolean): void;
export declare function removeAppLifeCycle(): void;
declare type TPageLifecycleRes = Promise<void> | void;
interface IPageLifecycle {
    beforePageCustomLaunch?: (query: any) => Promise<void>;
    onPageLoad?: (query: any) => TPageLifecycleRes;
    onPageShow?: () => TPageLifecycleRes;
    onPageReady?: () => TPageLifecycleRes;
    onPageHide?: () => TPageLifecycleRes;
    onPageUnload?: () => TPageLifecycleRes;
    onReachBottom?: () => TPageLifecycleRes;
    onShareAppMessage?: () => TPageLifecycleRes;
    onPageScroll?: () => TPageLifecycleRes;
    onResize?: () => TPageLifecycleRes;
}
export declare function generatePageLifecycleHandlers({ beforePageCustomLaunch, onPageLoad, onPageShow, onPageReady, onPageHide, onPageUnload, onReachBottom, onShareAppMessage, onPageScroll, onResize, }: IPageLifecycle, events: any): {
    beforePageCustomLaunch: (query: any) => Promise<void>;
    onPageLoad(query: any): any;
    onPageShow: (...args: any[]) => void;
    onPageReady: (...args: any[]) => void;
    onPageHide: (...args: any[]) => void;
    onPageUnload: (...args: any[]) => void;
    onReachBottom: (...args: any[]) => void;
    onShareAppMessage: (...args: any[]) => void;
    onPageScroll: (...args: any[]) => void;
    onResize: (...args: any[]) => void;
};
export declare function usePageLifeCycle({ beforePageCustomLaunch, onPageLoad, onPageShow, onPageReady, onPageHide, onPageUnload, onReachBottom, onShareAppMessage, onPageScroll, onResize, }: IPageLifecycle, context: {
    app: IAppAPI;
    page: IPageAPI;
    options: any;
}, deps?: any[]): void;
export declare function initWebConfig(app: any, appConfig: any): void;
export {};
