import { __awaiter, __generator } from "tslib";
import { LoginSource } from './types';
/**
 * 判断是否在企微内部打开
 */
export var inWxWork = function () {
    var ua = navigator.userAgent.toLowerCase();
    if (ua.indexOf('wxwork') !== -1) {
        return true;
    }
    return false;
};
export function getJson(url, data) {
    if (data === void 0) { data = {}; }
    return __awaiter(this, void 0, void 0, function () {
        var response;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, fetch(url, data)];
                case 1:
                    response = _a.sent();
                    return [4 /*yield*/, response.json()];
                case 2: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
export function getConfig(router) {
    return __awaiter(this, void 0, void 0, function () {
        var source, staticOrigin, config, version, hashVersion, path, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    source = router.getUrlParams('source');
                    staticOrigin = getStaticOrigin(router);
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 9, , 10]);
                    config = void 0;
                    if (!(source === LoginSource.PORTAL)) return [3 /*break*/, 2];
                    return [3 /*break*/, 8];
                case 2:
                    if (!(source === LoginSource.APIS)) return [3 /*break*/, 3];
                    return [3 /*break*/, 8];
                case 3:
                    version = router.getUrlParams('config_version') || '';
                    hashVersion = version.split('_')[0];
                    path = "".concat(router.getUrlParams('app_id'), "/").concat(getConfigName(version), ".json");
                    if (!(hashVersion === 'v1')) return [3 /*break*/, 5];
                    return [4 /*yield*/, getJson("".concat(staticOrigin, "/__auth/app/").concat(path))];
                case 4:
                    config = _a.sent();
                    return [3 /*break*/, 7];
                case 5: return [4 /*yield*/, getJson("".concat(staticOrigin, "/").concat(path))];
                case 6:
                    // 兼容老版本配置存储规则
                    config = _a.sent();
                    _a.label = 7;
                case 7: return [2 /*return*/, config];
                case 8: throw new Error("\u52A0\u8F7D\u914D\u7F6E\u5931\u8D25 source error ".concat(source));
                case 9:
                    e_1 = _a.sent();
                    throw new Error('加载配置失败');
                case 10: return [2 /*return*/];
            }
        });
    });
}
var staticOrigin;
export function getStaticOrigin(router) {
    if (!staticOrigin) {
        staticOrigin = location.origin;
        try {
            if (router.getUrlParams('s_domain')) {
                var url = new URL("https://".concat(router.getUrlParams('s_domain')));
                if (url.origin.endsWith('.tcloudbaseapp.com') || url.origin === '127.0.0.1') {
                    staticOrigin = url.origin;
                }
            }
        }
        catch (e) {
            throw new Error('s_domain参数错误');
        }
    }
    return staticOrigin;
}
export function getConfigName(version) {
    return "login.config".concat(version ? ".".concat(version) : '');
}
