"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.signInWidthProviderCode = exports.providerLogin = void 0;
var tslib_1 = require("tslib");
var global_api_1 = require("../../app/global-api");
// 用于三方登录跳转回的页面地址生成：默认为当前页面
function getProviderRedirectURI(providerId) {
    return location.href;
    // return location.origin + location.pathname;
}
function providerLogin(router, providerId, scope) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var cloudbase_1, auth, state, res, err_1;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 3, , 4]);
                    return [4 /*yield*/, global_api_1.app.cloud.getCloudInstance()];
                case 1:
                    cloudbase_1 = _a.sent();
                    auth = cloudbase_1.authInstance || cloudbase_1.auth;
                    state = "prd-".concat(providerId, "-").concat(Math.random().toString(36).slice(2));
                    return [4 /*yield*/, auth.genProviderRedirectUri({
                            provider_id: providerId,
                            provider_redirect_uri: getProviderRedirectURI(providerId),
                            state: state,
                            scope: scope,
                        })];
                case 2:
                    res = _a.sent();
                    location.replace(res.uri);
                    return [3 /*break*/, 4];
                case 3:
                    err_1 = _a.sent();
                    global_api_1.app.showToast({
                        title: err_1.message,
                        icon: 'error',
                    });
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    });
}
exports.providerLogin = providerLogin;
function signInWidthProviderCode(state, code) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var providerId, cloudbase, auth, res;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    providerId = state.replace(/prd-(.+)-.+/, '$1');
                    return [4 /*yield*/, global_api_1.app.cloud.getCloudInstance()];
                case 1:
                    cloudbase = _a.sent();
                    auth = cloudbase.authInstance || cloudbase.auth;
                    return [4 /*yield*/, auth.grantProviderToken({
                            provider_id: providerId,
                            provider_code: code,
                            // provider_redirect_uri: getProviderRedirectURI(providerId),
                        })];
                case 2:
                    res = _a.sent();
                    return [4 /*yield*/, auth.signInWithProvider({
                            provider_id: providerId,
                            provider_token: res.provider_token,
                        })];
                case 3: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.signInWidthProviderCode = signInWidthProviderCode;
//# sourceMappingURL=index.js.map