"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.tryWecomLogin = void 0;
var tslib_1 = require("tslib");
var helper_1 = require("./helper");
var router_1 = require("./router");
var types_1 = require("./types");
var index_1 = require("./index");
var _CACHE_MAP = {};
function tryWecomLogin(location, fallback) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var res, e_1;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    if (!_CACHE_MAP[location.href]) {
                        _CACHE_MAP[location.href] = wecomLogin(location);
                    }
                    return [4 /*yield*/, _CACHE_MAP[location.href]];
                case 1:
                    res = _a.sent();
                    if (res) {
                        _CACHE_MAP[location.href] = undefined;
                        return [2 /*return*/];
                    }
                    else {
                        fallback();
                    }
                    return [3 /*break*/, 3];
                case 2:
                    e_1 = _a.sent();
                    console.error('企微原地登录失败，fallback to sso登录', e_1);
                    fallback();
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    });
}
exports.tryWecomLogin = tryWecomLogin;
function wecomLogin(location) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var router, config, loginMethods, loginTypes, authList, wecomConfig;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    router = new router_1.Router(document.createElement('div'), location);
                    return [4 /*yield*/, (0, helper_1.getConfig)(router)];
                case 1:
                    config = _a.sent();
                    loginMethods = (config === null || config === void 0 ? void 0 : config.web) || [];
                    loginTypes = [];
                    authList = [];
                    wecomConfig = undefined;
                    loginMethods.forEach(function (item) {
                        if (!loginTypes.includes(item.type)) {
                            loginTypes.push(item.type);
                        }
                        if (item.type === types_1.LoginMethodType.AUTH) {
                            authList.push(item);
                        }
                        if (item.id === 'wecom') {
                            wecomConfig = item;
                        }
                    });
                    if (!wecomConfig) return [3 /*break*/, 3];
                    return [4 /*yield*/, (0, index_1.providerLogin)(router, wecomConfig.id)];
                case 2:
                    _a.sent();
                    return [2 /*return*/, true];
                case 3: return [2 /*return*/, false];
            }
        });
    });
}
//# sourceMappingURL=init.js.map