export declare enum Platform {
    WEB = "web",
    MINIPROGRAM = "miniprogram"
}
export declare enum StorageMode {
    SESSION = "session"
}
export declare enum LoginSource {
    PORTAL = "portal",
    APIS = "apis",
    APP = "app"
}
export declare enum AlginMode {
    LEFT = "left",
    CENTER = "center",
    RIGHT = "right"
}
export declare enum LoginMethodType {
    PASSWORD = "password",
    SMS = "sms",
    AUTH = "auth",
    MINIPROGRAM_PHONE = "miniprogram_phone",
    PORTAL_WECOM = "portal_wecom"
}
export interface LoginMethod {
    id: string;
    type: LoginMethodType;
    label: string;
    icon?: string;
}
export interface ILoginConfig {
    title?: string;
    name?: string;
    favicon?: string;
    logo: string;
    backgroundColor: string;
    backgroundImage?: string;
    alginMode?: AlginMode;
    [Platform.WEB]: LoginMethod[];
    [Platform.MINIPROGRAM]?: LoginMethod[];
    showDoc?: boolean;
    copyright?: string;
    agreement?: SettingItem;
}
export interface SettingItem {
    id?: string;
    enable?: boolean;
    type?: string;
    label?: string;
    value?: any;
    icon?: string;
    items?: SettingItem[];
}
export declare enum LoginErrorCode {
    NOT_SUPPORT_LOCAL_STORAGE = "not_support_local_storage",
    ACCESS_CODE_LOGIN_FAIL = "access_code_login_fail"
}
