import { AlginMode, LoginMethodType, Platform } from './types';

export const WECOM_ACCESS_PATH = 'weda.cloud.tencent.com/weda-auth-page/';

export const WECOM_CALLBACK_PATH = 'callback.weda.tencent-cloud.com';

export const FAVICON_URL = 'https://cloudcache.tencentcs.com/qcloud/app/resource/ac/favicon.ico';

export const SMS_METHOD = {
  id: `__${LoginMethodType.SMS}`,
  label: '短信验证码',
  type: LoginMethodType.SMS,
};

export const PASSWORD_METHOD = {
  id: `__${LoginMethodType.PASSWORD}`,
  label: '账户密码登录',
  type: LoginMethodType.PASSWORD,
};

export const PORTAL_WECOM_METHOD = {
  id: `__${LoginMethodType.PORTAL_WECOM}`,
  label: '企微登录',
  type: LoginMethodType.AUTH,
  icon: 'https://sso-1303824488.cos.ap-shanghai.myqcloud.com/wecom.svg',
};

export const APIS_CONFIG = {
  title: '微搭内容管理平台',
  favicon: FAVICON_URL,
  name: '腾讯云微搭低代码管理系统',
  logo: 'https://sso-1303824488.cos.ap-shanghai.myqcloud.com/logo.svg',
  alginMode: AlginMode.RIGHT,
  backgroundColor: '#fff',
  backgroundImage: 'https://sso-1303824488.cos.ap-shanghai.myqcloud.com/background-image.png',
  [Platform.WEB]: [PASSWORD_METHOD],
};
