import React, { useEffect } from 'react';
import { StatusTip } from 'tea-component';
import { useRequest } from 'ahooks';
import { getDescribeProcessInstanceDetail } from '../../services';
import HistoryFlow from './History';
import { useFlowContext } from '../FlowCard/Context';
import '../../styles/index.less';
import './extend.less';
export const ApprovalHistory = ({ className, style, ProcessInstanceId, ...rest }) => {
    const { data, loading, run } = useRequest(getDescribeProcessInstanceDetail, {
        manual: true,
    });
    const { callWorkflow, IS_WEDA_IDE, showToast } = useFlowContext();
    useEffect(() => {
        const getHistoryData = async () => {
            await run(ProcessInstanceId, IS_WEDA_IDE, callWorkflow, showToast);
        };
        getHistoryData();
    }, []);
    if (!data || !data.length || loading) {
        return (React.createElement("div", { style: { textAlign: 'center' } },
            React.createElement(StatusTip, { status: loading ? 'loading' : 'empty' })));
    }
    return React.createElement(HistoryFlow, { dataSource: data, className: className, style: style, ...rest });
};
