export function getModuleTextProps(props) {
    const moduleProps = {};
    Object.entries(props).forEach(([key, value]) => {
        if (key.startsWith('module')) {
            moduleProps[key] = value;
        }
    });
    return moduleProps;
}
export function getLineHeight(lineHeight) {
    const realLineHeight = +lineHeight;
    if (typeof realLineHeight === 'number') {
        return `${realLineHeight}rem`;
    }
    return lineHeight;
}
export function getModuleContentStyle(props) {
    const style = {
        color: props.moduleContentColor,
        fontSize: props.moduleContentFontSize,
        fontWeight: props.moduleContentFontWeight,
        lineHeight: getLineHeight(props.moduleContentLineHeight),
    };
    return style;
}
export function getModuleTitleStyle(props) {
    const style = {
        color: props.moduleTitleColor,
        fontSize: props.moduleTitleFontSize,
        fontWeight: props.moduleTitleFontWeight,
        lineHeight: getLineHeight(props.moduleTitleLineHeight),
    };
    return style;
}
