import React from 'react';
import { Text } from 'tea-component';
const omit = (prop, { [prop]: _, ...rest }) => rest;
export const FlowStatusText = (props) => {
    const { isCompleted, status, userTaskType } = props.flow || {};
    const getTagProps = () => {
        const props = {
            theme: 'warning',
            text: '待审批',
        };
        if (userTaskType === 2) {
            props.text = '待处理';
        }
        if (isCompleted) {
            if (status === 1) {
                props.theme = 'danger';
                props.text = '已终止';
            }
            else if (status === 2) {
                props.theme = 'danger';
                props.text = '已驳回';
            }
            else if (status === 4) {
                props.theme = 'danger';
                props.text = '已作废';
            }
            else {
                props.theme = 'success';
                props.text = userTaskType === 2 ? '已处理' : '审批通过';
            }
        }
        return props;
    };
    const { text, ...rest } = getTagProps();
    return (React.createElement(Text, { ...rest, style: omit('color', props.style) }, text));
};
