import React from 'react';
import { safeJsonParse } from '../../../../utils';
export const HighLightComment = ({ details }) => {
    const text = (details === null || details === void 0 ? void 0 : details.operationComment) || '';
    let dom = '';
    const positionMap = (details === null || details === void 0 ? void 0 : details.highlightPositionList) || '{}';
    const obj = safeJsonParse(positionMap);
    let startIndex = 0;
    const arr = Object.entries(obj);
    if (arr.length === 0) {
        return text;
    }
    for (const [start, end] of arr) {
        const name = text.substring(Number(start) + 1, end);
        const domTemp = (React.createElement(React.Fragment, null,
            text.substring(startIndex, Number(start)),
            React.createElement("span", { style: { color: '#2473F2' } }, `@${name}`)));
        dom = (React.createElement(React.Fragment, null,
            dom,
            domTemp));
        startIndex = end;
    }
    if (startIndex < text.length) {
        dom = (React.createElement(React.Fragment, null,
            dom,
            text.substring(startIndex, text.length)));
    }
    return React.createElement("span", null, dom);
};
