import React, { useEffect } from 'react';
import { UserTreeSelect } from '@cloudbase/weda-ui';
export function UserSelect(props) {
    const { multiple = true, isMobile = false, placeholder, visible = false, onClose } = props;
    useEffect(() => {
        const onBodyClick = (e) => {
            let element = e.target;
            if (element.closest('.wedatea2td-icon-close') || element.closest('.wedatea2td-btn--weak')) {
                onClose === null || onClose === void 0 ? void 0 : onClose();
            }
        };
        const evtOptions = { passive: true, capture: true };
        document.addEventListener('click', onBodyClick, evtOptions);
        return () => {
            document.removeEventListener('click', onBodyClick, evtOptions);
        };
    }, []);
    const onTreeSelectChange = (value) => {
        var _a, _b;
        const selectedData = multiple ? value.data : [value.data];
        const userList = selectedData === null || selectedData === void 0 ? void 0 : selectedData.map((user) => ({
            text: user.content,
            value: user.userId,
        }));
        (_a = props === null || props === void 0 ? void 0 : props.onChange) === null || _a === void 0 ? void 0 : _a.call(props, userList || []);
        (_b = props === null || props === void 0 ? void 0 : props.originOnChange) === null || _b === void 0 ? void 0 : _b.call(props, value);
        onClose === null || onClose === void 0 ? void 0 : onClose();
    };
    const selectProps = {
        labelVisible: false,
        modelType: 'model',
        decorator: null,
        multiple,
        showType: isMobile ? 'h5' : 'pc',
        dropDownStyle: { width: '190px' },
        size: 'auto-width',
        defaultValue: props.value || [],
        events: {
            change: onTreeSelectChange,
        },
        placeholder,
        modelOpen: visible,
        style: {
            display: 'none',
        },
    };
    return React.createElement(UserTreeSelect, { ...selectProps });
}
