import React, { useState, useEffect } from 'react';
import { safeJsonParse } from '../../../../utils';
import { UserSelect } from './UserSelect';
import './UserSelectMobile.less';
export const UserSelectMobile = (props) => {
    const { visible, approveField, mode, close, values } = props;
    const [selected, setSelected] = useState(values);
    useEffect(() => {
        const selectedAvatar = sessionStorage.getItem('selected');
        selectedAvatar && setSelected(safeJsonParse(selectedAvatar));
    }, []);
    const handleHighLightSelected = (selectedIds, selectedUser, flowData) => {
        let v = '';
        const { opinionUserMap, approveInfo } = flowData;
        selectedIds.forEach((id) => {
            const user = selectedUser.find((user) => (user === null || user === void 0 ? void 0 : user.UserId) === id) || {};
            const name = `@${user === null || user === void 0 ? void 0 : user.Name}`;
            v = `${v + name} `;
            if (!opinionUserMap[id]) {
                opinionUserMap[id] = name;
            }
        });
        flowData.approveInfo = approveInfo + v;
        flowData.opinionUserMap = { ...opinionUserMap };
    };
    const saveSelect = (selectedIds, selectedUser) => {
        var _a;
        const flowData = (_a = safeJsonParse(sessionStorage.getItem('FlowActionsMobile'))) !== null && _a !== void 0 ? _a : {};
        if (approveField === 'assigneeIds') {
            flowData.assigneeIds = selectedIds;
            sessionStorage.setItem('hasSignSubmit', 'hasSignSubmit');
        }
        else if (approveField === 'highLightApprovers') {
            handleHighLightSelected(selectedIds, selectedUser, flowData);
        }
        else {
            flowData[approveField] = selectedIds;
        }
        sessionStorage.setItem('FlowActionsMobile', JSON.stringify(flowData));
        sessionStorage.setItem(approveField, JSON.stringify(selectedUser));
        close === null || close === void 0 ? void 0 : close();
    };
    const onUserSelectChange = (rows) => {
        var _a;
        const isMultiple = mode === 'multiple';
        const ids = isMultiple ? rows.value : [rows.value];
        const users = (_a = rows.data) === null || _a === void 0 ? void 0 : _a.map((user) => ({ Name: user.content, UserId: user.id }));
        saveSelect(ids, users);
    };
    useEffect(() => {
        let lastTouchEnd = 0;
        const touchstartFn = (event) => {
            if (event.touches.length > 1) {
                event.preventDefault();
            }
        };
        const touchendFn = (event) => {
            const now = new Date().getTime();
            if (now - lastTouchEnd <= 300) {
                event.preventDefault();
            }
            lastTouchEnd = now;
        };
        const gesturestartFn = (event) => {
            event.preventDefault();
        };
        document.addEventListener('touchstart', touchstartFn);
        document.addEventListener('touchend', touchendFn, false);
        // 阻止双指放大
        document.addEventListener('gesturestart', gesturestartFn);
        return () => {
            document.removeEventListener('touchstart', touchstartFn);
            document.removeEventListener('touchend', touchendFn);
            document.removeEventListener('gesturestart', gesturestartFn);
        };
    }, []);
    return visible ? (React.createElement(UserSelect, { visible: true, isMobile: true, multiple: mode === 'multiple', value: selected, originOnChange: onUserSelectChange, onClose: () => {
            close === null || close === void 0 ? void 0 : close();
        } })) : null;
};
