import { useState, useEffect } from 'react';
export function useElementMediaQuery(element, maxWidth = 768) {
    const [isNarrowElement, setIsNarrowElement] = useState(false);
    useEffect(() => {
        if (element) {
            const resizeObserver = new ResizeObserver((entries) => {
                var _a, _b;
                const width = (_b = (_a = entries === null || entries === void 0 ? void 0 : entries[0]) === null || _a === void 0 ? void 0 : _a.contentRect) === null || _b === void 0 ? void 0 : _b.width;
                setIsNarrowElement(width < maxWidth);
            });
            resizeObserver.observe(element);
        }
    }, [element]);
    return isNarrowElement;
}
