/// <reference types="react" />
/** 流程模块组件通用属性 */
export interface IFlowFrameCommonProps {
    /** 来源于Ide的属性 */
    ide: Record<string, any>;
    /** 流程本地通用属性 */
    flowLocalProps: IFlowLocalProps;
    /** 流程通用数据属性 来源于接口 */
    commonFlowData: ICommonFlowDataProps;
    /** 是否在加载中 */
    loading: boolean;
    /** 子元素 */
    children?: React.ReactNode;
}
/** 流程本地通用属性 */
export interface IFlowLocalProps {
    /** 是否为小屏宽度的元素（元素宽度小于768） */
    isNarrowElement: boolean;
    /** 是否是小屏视图 */
    isH5: boolean;
    /** 是否再微搭IDE中 */
    isWedaIde: boolean;
    /** 微搭SDK通用请求方法 */
    callWedaApi: (...args: any[]) => any;
    /** 拥有异常处理的JSON.parse */
    safeJsonParse: (val: any) => any;
    /** 当前页面类型  来自浏览器参数 */
    currentPageType: string;
}
/** 流程通用数据属性 来源于接口 */
export declare class ICommonFlowDataProps {
    flowDetail: IFlowDetailProps;
    pageInfo: IPageInfoProps;
    steps: any[];
    ccUserMaps: Record<string, string>;
    flowLoadData: {
        initialValues: any;
        formType: string;
    };
}
export declare class IFlowDetailProps {
    instanceId: string;
    name: string;
    description: string;
    startedBy: string;
    startUserId: string | number;
    currentApprover: string;
    startTime: number | null;
    isCompleted: boolean;
    startAppCode: string;
    startAppName: string;
    currentNodeId: string;
    currentNodeName: string;
    currentNodeType: number;
    taskId: string;
    flowCode: string;
    flowVersion: string;
    flag: number;
    canApprove: boolean;
    canDelete: boolean;
    tenantZoneId: string;
    operationName: string;
    userTaskType: number;
    ccId: string;
    endTime: number | null;
}
export declare class IPageInfoProps {
    pageUrl: string;
    variableInfos: {
        ObjectListMap: any[];
        ObjectMap: any[];
    };
    appCode: string;
    show: boolean;
    showRevoke: boolean;
    showSubmitApp: boolean;
    showCarbonCopy: boolean;
    showTurnToPerson: boolean;
    showAddAssignee: boolean;
    showRollBack: boolean;
    outEntityCodes: any[];
    buttons: Record<number, string>;
    dataSourceInputParams: {
        recordId: string;
        entityCode: string;
        flag: boolean;
        paramCode: string;
        scope: string;
        name: string;
        fieldValueMap: Record<string, any>;
        appCode: number;
        fieldType: string;
    }[];
}
