import { getPageQuery } from '../../../utils';
import { STATUS_NUMBER_MAPPING, STATUS, PAGE_TYPE } from '../constants';
export class CommonFlowDataUtils {
    /** 转换流程接口中的变量数据 */
    static translateObjectMap(pageDetail) {
        var _a;
        const objectMap = ((_a = pageDetail === null || pageDetail === void 0 ? void 0 : pageDetail.variableInfos) === null || _a === void 0 ? void 0 : _a.objectMap) || [];
        if (objectMap === null || objectMap === void 0 ? void 0 : objectMap.length) {
            return objectMap.reduce((prev, curr) => {
                if (curr.entityCode) {
                    prev[curr.entityCode] = { ...curr === null || curr === void 0 ? void 0 : curr.fieldValueMap, _id: curr.recordId };
                }
                return prev;
            }, {});
        }
    }
    /** 获取流程自定义页面表单状态 */
    static getFormState(params) {
        const { isWedaIde, currentPageType } = params;
        const couldWriteForm = [PAGE_TYPE.DRAFT, PAGE_TYPE.TO_DO, PAGE_TYPE.CREATEFLOW];
        return {
            isReadonly: isWedaIde ? false : !couldWriteForm.includes(currentPageType),
        };
    }
    /** 获取当前流程页面参数 */
    static getCurrentFlowPageQuery(isWedaIde) {
        const { flowTaskId, pageType: queryPageType } = getPageQuery();
        const currentPageType = isWedaIde ? PAGE_TYPE.CREATEFLOW : queryPageType;
        return {
            flowTaskId: flowTaskId,
            currentPageType: currentPageType,
        };
    }
}
/** 转换流程记录数据 */
Object.defineProperty(CommonFlowDataUtils, "transProcessData", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: (process, safeJsonParse) => {
        return process.map((value) => {
            var _a, _b;
            const item = { ...value, status: STATUS_NUMBER_MAPPING === null || STATUS_NUMBER_MAPPING === void 0 ? void 0 : STATUS_NUMBER_MAPPING[process === null || process === void 0 ? void 0 : process.status] };
            const details = { ...item.contentInfo, action: STATUS_NUMBER_MAPPING === null || STATUS_NUMBER_MAPPING === void 0 ? void 0 : STATUS_NUMBER_MAPPING[(_a = item === null || item === void 0 ? void 0 : item.contentInfo) === null || _a === void 0 ? void 0 : _a.action] };
            if (item.result === '待审批') {
                item.status = STATUS.PENDING;
            }
            else if (item.result === '待处理') {
                item.status = STATUS.HANDLING;
            }
            else {
                item.status = STATUS[details.action];
                if (details.action === STATUS.SKIP_PASS) {
                    item.status =
                        ((_b = safeJsonParse(details.operation)[0].id) === null || _b === void 0 ? void 0 : _b.toString()) === '2' ? STATUS.SKIP_PASS : STATUS.SKIP_DOWN; // 2同意 3驳回
                }
            }
            let files = [];
            if (details.attachmentInfo) {
                files = safeJsonParse((details === null || details === void 0 ? void 0 : details.attachmentInfo) || '[]') || [];
            }
            item.files = files;
            return item;
        });
    }
});
