import React from 'react';
import moment from 'moment';
import { Text, Button, Justify } from 'tea-component';
import { FlowStatusText, FlowModuleText, getModuleContentStyle, getModuleTitleStyle, getModuleTextProps, } from '../../components';
import { pressTask } from './utils';
import './BasicMobile.less';
export const BasicMobile = (props) => {
    const { commonFlowData, flowLocalProps, ide } = props;
    const { flowDetail, pageInfo } = commonFlowData;
    const { currentPageType, isWedaIde, callWedaApi } = flowLocalProps;
    const textProps = getModuleTextProps(ide);
    const flowModelContentStyle = getModuleContentStyle(ide);
    // 是否为发起流程页面
    const isStartFlowPage = ['DRAFT', 'CREATEFLOW', 'TODO'].includes(currentPageType) && (pageInfo === null || pageInfo === void 0 ? void 0 : pageInfo.showSubmitApp);
    const onPressTask = () => {
        const params = { instanceId: flowDetail.instanceId };
        const options = { isWedaIde, callWedaApi };
        pressTask(params, options);
    };
    if (isStartFlowPage) {
        return (React.createElement("div", { className: "progress-mb--header" },
            React.createElement(FlowModuleText.Title, { ...textProps, className: "progress-mb--header__module-title" }),
            React.createElement("div", { className: "progress-mb--title", style: { marginBottom: 0, ...getModuleTitleStyle(ide) } }, flowDetail === null || flowDetail === void 0 ? void 0 : flowDetail.name)));
    }
    return (React.createElement("div", { className: "progress-mb--header" },
        React.createElement(FlowModuleText.Title, { ...textProps, className: "progress-mb--header__module-title" }),
        React.createElement("div", { className: "progress-mb--title", style: { display: 'flex', justifyContent: 'space-between' } },
            React.createElement("span", { style: flowModelContentStyle }, flowDetail === null || flowDetail === void 0 ? void 0 : flowDetail.name),
            currentPageType === 'CREATE' && !(flowDetail === null || flowDetail === void 0 ? void 0 : flowDetail.isCompleted) && (React.createElement(Button, { type: "link", style: { fontSize: '14px', flexShrink: '0' }, onClick: onPressTask }, "\u50AC\u529E"))),
        React.createElement("div", { className: "progress-mb--header__info" },
            React.createElement(Text, { theme: "weak", style: flowModelContentStyle },
                "\u53D1\u8D77\u4EBA\uFF1A",
                flowDetail.startedBy)),
        React.createElement(Justify, { className: "progress-mb--header__info", left: React.createElement(Text, { theme: "weak", style: flowModelContentStyle },
                "\u53D1\u8D77\u65F6\u95F4\uFF1A",
                flowDetail.startTime ? moment(flowDetail.startTime).format('YYYY-MM-DD HH:mm:ss') : '--',
                ' '), right: React.createElement(FlowStatusText, { flow: flowDetail, style: getModuleContentStyle(ide) }) })));
};
