import React from 'react';
import { Tabs } from '@cloudbase/weda-ui';
import ModelFlowBasic from '../basic';
import ModelFlowChart from '../chart';
import ModelFlowControl from '../control';
import ModelFlowLayout from '../layout';
import ModelFlowProcess from '../process';
const ModelFlow = (props) => {
    const commonProps = {
        events: (props === null || props === void 0 ? void 0 : props.events) || {},
    };
    return (React.createElement(ModelFlowLayout, { ...props, flowContentSlot: React.createElement(Tabs, { isMultipleSlot: true, events: { change: () => { } }, tabs: [
                { value: 'process', title: '流程详情' },
                { value: 'chart', title: '流转图示' },
            ], panel1: React.createElement(React.Fragment, null,
                React.createElement(ModelFlowBasic, { ...commonProps }),
                React.createElement(ModelFlowProcess, { ...commonProps })), panel2: React.createElement(ModelFlowChart, { ...commonProps }), selectedIndex: 0 }), flowControlSlot: React.createElement(ModelFlowControl, { ...commonProps }) }));
};
export default ModelFlow;
