import React from 'react';
import { Button, Modal, Form, Select } from 'tea-component';
import classNames from 'classnames';
import { UserSelectModel } from '../../components';
import { useControlContext } from './provider';
import { ACTION_TYPE } from './constants';
import { ApprovalDrawer } from './ApprovalDrawer';
import { FlowTaskInfoModal } from './FlowTaskInfoModal';
import './Control.less';
export const FlowControl = (props) => {
    const { commonFlowData, flowLocalProps, ide } = props;
    const { flowDetail, pageInfo } = commonFlowData;
    const { isWedaIde, currentPageType } = flowLocalProps;
    const { 
    // ControlModel
    userModalVisible, submitApplyLoading, ccUserModelVisible, ccUsers, ifSubmitAndCc, setCcUsers, setCcUserModelVisible, onClearInstance, onControlChick, setUserModalVisible, onUserModalVisibleChange, onAddCounterSign, 
    // RevokeModel
    showRevokeModal, showBackModal, backNodeList, backNode, setShowRevokeModal, doneRevokeFn, doneBackFn, setShowBackModal, getNodeList, setBackNode, } = useControlContext();
    const onClickGoBack = async () => {
        await getNodeList();
        setShowBackModal(true);
    };
    const footerClassNames = classNames('mf-progress-footer', {
        'mf-progress-footer__app-page': !isWedaIde,
    });
    const containerClassNames = classNames('page-process__progress', {
        'page-process__progress__app-page': !isWedaIde,
    });
    const renderButtonGroup = () => {
        var _a, _b;
        if (['CREATE', 'DONE'].includes(currentPageType) && (pageInfo === null || pageInfo === void 0 ? void 0 : pageInfo.showRevoke)) {
            return (React.createElement("div", { className: footerClassNames },
                React.createElement(Button, { type: "weak", onClick: () => setShowRevokeModal(true) }, "\u64A4\u9500")));
        }
        if (['DRAFT', 'CREATEFLOW', 'TODO'].includes(currentPageType) && (pageInfo === null || pageInfo === void 0 ? void 0 : pageInfo.show)) {
            if (pageInfo === null || pageInfo === void 0 ? void 0 : pageInfo.showSubmitApp) {
                return (React.createElement("div", { className: footerClassNames },
                    React.createElement(ButtonLayout, { gap: 10 },
                        ifSubmitAndCc ? (React.createElement(Button, { type: "link", onClick: () => setCcUserModelVisible(true) }, `+抄送人(${ccUsers.length || 0})`)) : null,
                        React.createElement(Button, { type: "primary", loading: submitApplyLoading, onClick: (e) => onControlChick(ACTION_TYPE.SUBMIT, e) }, `${((_a = pageInfo === null || pageInfo === void 0 ? void 0 : pageInfo.buttons) === null || _a === void 0 ? void 0 : _a[3]) || '提交申请'}`),
                        (flowDetail === null || flowDetail === void 0 ? void 0 : flowDetail.canDelete) && (React.createElement(React.Fragment, null,
                            React.createElement(Button, { type: "weak", onClick: (e) => onControlChick(ACTION_TYPE.SAVEDRAFT, e) }, "\u4FDD\u5B58\u8349\u7A3F"),
                            React.createElement(Button, { type: "weak", onClick: onClearInstance }, "\u53D6\u6D88"))))));
            }
            return (React.createElement("div", { className: footerClassNames },
                React.createElement(ButtonLayout, null,
                    (flowDetail === null || flowDetail === void 0 ? void 0 : flowDetail.userTaskType) === 2 ? (React.createElement(Button, { type: "primary", onClick: (e) => onControlChick(ACTION_TYPE.HANDLE, e) }, flowDetail === null || flowDetail === void 0 ? void 0 : flowDetail.operationName)) : (React.createElement(ButtonLayout, { gap: 10 },
                        React.createElement(Button, { type: "primary", onClick: (e) => onControlChick(ACTION_TYPE.AGREE, e) }, `${(pageInfo === null || pageInfo === void 0 ? void 0 : pageInfo.buttons) ? pageInfo === null || pageInfo === void 0 ? void 0 : pageInfo.buttons[1] : '同意'}`),
                        React.createElement(Button, { type: "weak", onClick: (e) => onControlChick(ACTION_TYPE.REJECT, e) }, `${(pageInfo === null || pageInfo === void 0 ? void 0 : pageInfo.buttons) ? pageInfo === null || pageInfo === void 0 ? void 0 : pageInfo.buttons[2] : '拒绝'}`))),
                    (pageInfo === null || pageInfo === void 0 ? void 0 : pageInfo.showTurnToPerson) ? (React.createElement(Button, { type: "weak", className: "mf-progress-footer__btn-line", onClick: (e) => onControlChick(ACTION_TYPE.TRANSFER, e) }, "\u8F6C\u529E")) : null,
                    (pageInfo === null || pageInfo === void 0 ? void 0 : pageInfo.showRollBack) && (React.createElement(Button, { type: "weak", className: "mf-progress-footer__btn-line", onClick: onClickGoBack }, "\u56DE\u9000")),
                    (pageInfo === null || pageInfo === void 0 ? void 0 : pageInfo.showAddAssignee) && (React.createElement(Button, { type: "weak", className: "mf-progress-footer__btn-line", onClick: onUserModalVisibleChange }, "\u52A0\u7B7E")))));
        }
        if (['DRAFT', 'CREATEFLOW'].includes(currentPageType)) {
            return (React.createElement("div", { className: footerClassNames },
                React.createElement(Button, { type: "primary", loading: submitApplyLoading, onClick: (e) => onControlChick(ACTION_TYPE.SUBMIT, e) }, `${((_b = pageInfo === null || pageInfo === void 0 ? void 0 : pageInfo.buttons) === null || _b === void 0 ? void 0 : _b[3]) || '提交申请'}`),
                React.createElement(Button, { type: "weak", onClick: (e) => onControlChick(ACTION_TYPE.SAVEDRAFT, e) }, "\u4FDD\u5B58\u8349\u7A3F"),
                React.createElement(Button, { type: "weak", onClick: onClearInstance }, "\u53D6\u6D88")));
        }
    };
    return (React.createElement("div", { ...ide },
        React.createElement("div", { className: containerClassNames },
            renderButtonGroup(),
            React.createElement(Modal, { visible: showBackModal, caption: '流程回退', onClose: () => setShowBackModal(false) },
                React.createElement(Modal.Body, null,
                    React.createElement(Form, null,
                        React.createElement(Form.Item, { label: '选择回退节点' },
                            React.createElement(Select, { size: "full", appearance: "button", matchButtonWidth: true, options: backNodeList, value: backNode, onChange: (value) => setBackNode(value) })))),
                React.createElement(Modal.Footer, null,
                    React.createElement(Button, { type: "primary", disabled: (backNodeList === null || backNodeList === void 0 ? void 0 : backNodeList.length) === 0, onClick: () => doneBackFn() }, "\u786E\u5B9A"),
                    React.createElement(Button, { type: "weak", onClick: () => setShowBackModal(false) }, "\u53D6\u6D88"))),
            React.createElement(Modal, { visible: showRevokeModal, caption: '撤销流程提醒', onClose: () => setShowRevokeModal(false) },
                React.createElement(Modal.Body, null, '流程正在进行中，确认撤销此流程？'),
                React.createElement(Modal.Footer, null,
                    React.createElement(Button, { type: "primary", onClick: () => doneRevokeFn({ client: 'pc', currentPageType }) }, "\u786E\u5B9A"),
                    React.createElement(Button, { type: "weak", onClick: () => setShowRevokeModal(false) }, "\u53D6\u6D88"))),
            React.createElement(UserSelectModel, { visible: userModalVisible, onChange: (val) => val.length && onAddCounterSign(val), onClose: () => setUserModalVisible(false) }),
            React.createElement(UserSelectModel, { value: ccUsers, visible: ccUserModelVisible, onChange: (val) => val.length && setCcUsers(val), onClose: () => setCcUserModelVisible(false) }),
            React.createElement(FlowTaskInfoModal, null),
            React.createElement(ApprovalDrawer, { pageInfo: pageInfo, flowDetail: flowDetail }))));
};
export const ButtonLayout = ({ children, gap }) => {
    return (React.createElement("div", { className: "mf-progress-footer__btn-group", style: { gap: gap || 0 } }, children));
};
