import React from 'react';
import { Button, Status, Text, StatusTip } from 'tea-component';
import { Popup } from 'react-vant';
import { UserSelectModel } from '../../components';
import { useControlContext } from './provider';
import { ACTION_TYPE } from './constants';
import { ApprovalPopup } from './ApprovalPopup';
import { ButtonLayout } from './Control';
import './ControlMobile.less';
export const FlowControlMobile = (props) => {
    const { commonFlowData, flowLocalProps, ide } = props;
    const { pageInfo, flowDetail } = commonFlowData;
    const { safeJsonParse, currentPageType } = flowLocalProps;
    const { 
    // ControlModel
    submitApplyLoading, showMoreAction, ifSubmitAndCc, ccUsers, onClearInstance, onControlChick, onShowMoreVisibleChange, loadingAssign, 
    // RevokeModel
    showRevokeModal, showBackModal, backNodeList, backNode, setShowRevokeModal, doneRevokeFn, doneBackFn, setShowBackModal, getNodeList, setBackNode, onUserSelectModalInfoChange, setUserSelectModelVisible, userSelectApproveField, userSelectModelVisible, userSelectMode, } = useControlContext();
    const onClickRollBack = async () => {
        await getNodeList();
        onShowMoreVisibleChange();
        setShowBackModal(true);
    };
    const onClickAddCcUser = () => {
        setUserSelectModelVisible(true);
        onUserSelectModalInfoChange({ approveField: 'ccUsers', mode: 'multiple' });
    };
    const buttonActionMap = {
        showTurnToPerson: {
            label: '转办',
            action: (e) => onControlChick(ACTION_TYPE.TRANSFER, e),
        },
        showRollBack: {
            label: '回退',
            action: async () => {
                await getNodeList();
                setShowBackModal(true);
            },
        },
        showAddAssignee: {
            label: '加签',
            action: () => {
                onShowMoreVisibleChange();
                sessionStorage.setItem('selected', JSON.stringify([]));
                sessionStorage.setItem('FlowActionsMobile', JSON.stringify({
                    instanceId: flowDetail.instanceId,
                    nodeId: flowDetail.currentNodeId,
                    taskId: flowDetail.taskId,
                    assigneeIds: [],
                }));
                sessionStorage.setItem('last-url', location.href);
                setUserSelectModelVisible(true);
                onUserSelectModalInfoChange({ approveField: 'assigneeIds', mode: 'multiple' });
            },
        },
    };
    const renderButtonGroup = () => {
        var _a;
        if (['CREATE', 'DONE'].includes(currentPageType) && (pageInfo === null || pageInfo === void 0 ? void 0 : pageInfo.showRevoke)) {
            return (React.createElement("div", { className: "mf-progress-mb--footer" },
                React.createElement(Button, { type: "primary", onClick: () => setShowRevokeModal(true) }, "\u64A4\u9500")));
        }
        if (['DRAFT', 'CREATEFLOW', 'TODO'].includes(currentPageType) && (pageInfo === null || pageInfo === void 0 ? void 0 : pageInfo.show)) {
            return (React.createElement("div", { className: "mf-progress-mb--footer" }, (pageInfo === null || pageInfo === void 0 ? void 0 : pageInfo.showSubmitApp) ? (React.createElement(ButtonLayout, { gap: 10 },
                flowDetail.canDelete ? (React.createElement(Button, { type: "link", onClick: (e) => onControlChick(ACTION_TYPE.SAVEDRAFT) }, "\u4FDD\u5B58\u8349\u7A3F")) : null,
                ifSubmitAndCc ? (React.createElement(Button, { type: "link", onClick: onClickAddCcUser }, `+抄送人(${ccUsers.length || 0})`)) : null,
                React.createElement(Button, { type: "primary", loading: submitApplyLoading, onClick: (e) => onControlChick(ACTION_TYPE.SUBMIT) }, `${((_a = pageInfo === null || pageInfo === void 0 ? void 0 : pageInfo.buttons) === null || _a === void 0 ? void 0 : _a[3]) || '提交申请'}`),
                flowDetail.canDelete ? (React.createElement(Button, { type: "weak", onClick: onClearInstance }, "\u53D6\u6D88")) : null)) : (React.createElement(ButtonLayout, { gap: 10 },
                ['showTurnToPerson', 'showRollBack', 'showAddAssignee'].filter((key) => pageInfo[key]).length >= 2 ? (React.createElement(Button, { type: "link", onClick: onShowMoreVisibleChange }, "\u66F4\u591A")) : (['showTurnToPerson', 'showRollBack', 'showAddAssignee']
                    .filter((key) => pageInfo[key])
                    .map((key, actionIndex) => {
                    const { label, action } = buttonActionMap[key];
                    return (React.createElement(Button, { key: `actionItem-${actionIndex}`, className: "apa-height-xl tea-mr-4n tea-mt-1n", type: "link", onClick: action }, label));
                })),
                flowDetail.userTaskType === 2 ? (React.createElement(Button, { type: "primary", style: { flex: 3 }, onClick: (e) => onControlChick(ACTION_TYPE.HANDLE, e) }, `${flowDetail.operationName}`)) : (React.createElement(React.Fragment, null,
                    React.createElement(Button, { onClick: (e) => onControlChick(ACTION_TYPE.REJECT, e) }, `${(pageInfo === null || pageInfo === void 0 ? void 0 : pageInfo.buttons) ? pageInfo === null || pageInfo === void 0 ? void 0 : pageInfo.buttons[2] : '拒绝'}`),
                    React.createElement(Button, { type: "primary", onClick: (e) => onControlChick(ACTION_TYPE.AGREE, e) }, `${(pageInfo === null || pageInfo === void 0 ? void 0 : pageInfo.buttons) ? pageInfo === null || pageInfo === void 0 ? void 0 : pageInfo.buttons[1] : '同意'}`)))))));
        }
    };
    return (React.createElement("div", { ...ide },
        renderButtonGroup(),
        React.createElement(Popup, { className: "cp-mobile-dialog apa-m-overlay approval-progress__more--dialog", visible: showMoreAction, onClose: onShowMoreVisibleChange, 
            // disableCloseIcon={true}
            closeIcon: false, position: "bottom" },
            React.createElement("div", { className: "apa-m-overlay__body" },
                React.createElement("div", { className: "approval-progress__more--btns" },
                    (pageInfo === null || pageInfo === void 0 ? void 0 : pageInfo.showTurnToPerson) && (React.createElement("div", { className: "approval-progress__more--btn", onClick: (e) => {
                            onShowMoreVisibleChange();
                            onControlChick(ACTION_TYPE.TRANSFER, e);
                        } },
                        React.createElement("p", { style: { fontSize: 14 } }, "\u8F6C\u529E"),
                        React.createElement("p", null,
                            React.createElement(Text, { theme: "label" }, "\u9009\u62E9\u8F6C\u529E\u4EBA\u5458")))),
                    (pageInfo === null || pageInfo === void 0 ? void 0 : pageInfo.showRollBack) && (React.createElement("div", { className: "approval-progress__more--btn", onClick: onClickRollBack },
                        React.createElement("p", { style: { fontSize: 14 } }, "\u56DE\u9000"),
                        React.createElement("p", null,
                            React.createElement(Text, { theme: "label" }, "\u56DE\u9000\u81F3\u6307\u5B9A\u8282\u70B9")))),
                    (pageInfo === null || pageInfo === void 0 ? void 0 : pageInfo.showAddAssignee) && (React.createElement("div", { className: "approval-progress__more--btn", onClick: buttonActionMap.showAddAssignee.action },
                        React.createElement("p", { style: { fontSize: 14 } }, "\u52A0\u7B7E"),
                        React.createElement("p", null,
                            React.createElement(Text, { theme: "label" }, "\u9009\u62E9\u52A0\u7B7E\u4EBA\u5458"))))),
                React.createElement("div", { className: "approval-progress__more--footer" },
                    React.createElement(Text, { theme: "label", onClick: onShowMoreVisibleChange }, "\u53D6\u6D88")))),
        React.createElement(Popup, { className: "confim-popup", visible: showRevokeModal, onClose: () => setShowRevokeModal(false) },
            React.createElement(React.Fragment, null,
                React.createElement("h3", { className: "popup-header" }, "\u64A4\u9500\u6D41\u7A0B"),
                React.createElement("div", { className: "popup-body" }, "\u6D41\u7A0B\u6B63\u5728\u5BA1\u6279\u6D41\u8F6C\u4E2D\uFF0C\u786E\u5B9A\u64A4\u9500\u6D41\u7A0B\uFF1F"),
                React.createElement("div", { className: "popup-footer" },
                    React.createElement("span", { onClick: () => setShowRevokeModal(false) }, "\u53D6\u6D88"),
                    React.createElement("span", { className: "confirm-btn", onClick: () => doneRevokeFn({ client: 'mobile', currentPageType }) }, "\u786E\u5B9A")))),
        React.createElement(Popup, { visible: loadingAssign, className: "assign-modal" },
            React.createElement(StatusTip, { status: "loading", loadingText: "\u52A0\u7B7E\u4E2D...", style: { color: '#fff' } })),
        React.createElement(Popup, { className: "flow-popup", visible: showBackModal, position: "bottom", onClose: () => setShowBackModal(false) },
            React.createElement("h3", { className: "flow-popup-title" },
                React.createElement("span", { className: "left", onClick: () => setShowBackModal(false) }, "\u53D6\u6D88"),
                React.createElement("span", { className: "center" }, "\u8BF7\u9009\u62E9\u56DE\u9000\u8282\u70B9"),
                React.createElement("span", { className: "right", onClick: () => {
                        doneBackFn();
                    } }, "\u5B8C\u6210")),
            (backNodeList === null || backNodeList === void 0 ? void 0 : backNodeList.length) ? (React.createElement("ul", { className: "list-content" }, backNodeList === null || backNodeList === void 0 ? void 0 : backNodeList.map((item) => (React.createElement("li", { key: item.value, className: backNode === item.value ? 'list-checked' : '', onClick: () => setBackNode(item.value) },
                React.createElement("span", null, item.text)))))) : (React.createElement(Status, { icon: "blank", size: "l", title: "\u6682\u65E0\u53EF\u56DE\u9000\u8282\u70B9" }))),
        userSelectModelVisible ? (React.createElement(UserSelectModel, { visible: true, approveField: userSelectApproveField, mode: userSelectMode, close: () => setUserSelectModelVisible(false), mobileModel: true, values: ccUsers.map((user) => user.value) })) : null,
        React.createElement(ApprovalPopup, { pageInfo: pageInfo, flowDetail: flowDetail, safeJsonParse: safeJsonParse })));
};
