import React, { useEffect, useState } from 'react';
import { Modal, SelectMultiple, Button, Form } from 'tea-component';
// import { history } from 'umi';
import { useControlContext } from './provider';
import './FlowTaskInfoModal.less';
export const FlowTaskInfoModal = (props) => {
    // const { visible, setVisible, flowTaskInfoList, flowTaskIds, setFlowTaskIds, allInfos } = props;
    const { flowTaskInfoList, flowTaskInfoModalVisible, flowTaskIds, setFlowTaskIds, onCloseFlowTaskInfoModal } = useControlContext();
    const [options, setOptions] = useState([]);
    useEffect(() => {
        const tempOptions = [];
        flowTaskInfoList.forEach((item) => {
            tempOptions.push({
                text: item === null || item === void 0 ? void 0 : item.assigneeName,
                value: item === null || item === void 0 ? void 0 : item.waitFlowTaskId,
                assignee: item === null || item === void 0 ? void 0 : item.assignee,
            });
        });
        setOptions(tempOptions);
    }, [flowTaskInfoList]);
    return (React.createElement(Modal, { visible: flowTaskInfoModalVisible, caption: '选择下一节点处理人', onClose: onCloseFlowTaskInfoModal },
        React.createElement(Modal.Body, null,
            React.createElement(Form, { style: { marginBottom: '5px' } },
                React.createElement(Form.Item, { label: '选择处理人', className: "flow_center_next_approve-form_item" },
                    React.createElement(SelectMultiple, { appearance: "button", size: 'full', searchable: true, matchButtonWidth: true, staging: false, options: options, onChange: (val) => {
                            setFlowTaskIds(val);
                        }, value: flowTaskIds })))),
        React.createElement(Modal.Footer, null,
            React.createElement(Button, { type: "primary", onClick: onCloseFlowTaskInfoModal }, "\u786E\u5B9A"),
            React.createElement(Button, { type: "weak", onClick: onCloseFlowTaskInfoModal }, "\u53D6\u6D88"))));
};
