import React, { createContext, useContext } from 'react';
import { useControlModel } from './useControlModel';
import { useRevokeAndBackHook } from './useRevokeAndBackHook';
import { useMobileModel } from './useMobileModel';
const Context = createContext({});
export const ControlProvider = (props) => {
    const control = useControlModel(props);
    const revoke = useRevokeAndBackHook(props);
    const mobile = useMobileModel(props, { setCcUsers: control.setCcUsers });
    const value = {
        ...control,
        ...revoke,
        ...mobile,
    };
    return React.createElement(Context.Provider, { value: value }, props.children);
};
export const useControlContext = () => useContext(Context);
