import { useState, useEffect } from 'react';
import { postApprovalSign } from '../../../services';
export const useMobileModel = (params, controlModel) => {
    const { safeJsonParse, callWedaApi } = params.flowLocalProps;
    const { setCcUsers } = controlModel;
    const [showMoreAction, setShowMoreAction] = useState(false);
    const [userSelectModelVisible, setUserSelectModelVisible] = useState(false);
    const [userSelectApproveField, setUserSelectApproveField] = useState('');
    const [userSelectMode, setUserSelectMode] = useState('');
    const [fileList, setFileList] = useState([]);
    const [approvers, setApprovers] = useState([]);
    const [approver, setApprover] = useState('');
    const [opinionUserMap, setOpinionUserMap] = useState({});
    const [highlightPositionMap, setHighlightPositionMap] = useState({});
    const [loadingAssign, setLoadingAssign] = useState(false);
    useEffect(() => {
        if (!userSelectModelVisible) {
            const popupData = sessionStorage.getItem('FlowActionsMobile');
            const hasSignSubmit = sessionStorage.getItem('hasSignSubmit');
            const ccUserFormStorage = safeJsonParse(sessionStorage.getItem('ccUsers'));
            if (popupData) {
                const pageActionData = safeJsonParse(popupData);
                const { opinionUserMap, highlightPositionMap, approver, approvers, fileList, ccUsers } = pageActionData;
                setApprover(approver || []);
                setApprovers(approvers || []);
                setOpinionUserMap({ ...opinionUserMap });
                setHighlightPositionMap({ ...highlightPositionMap });
                setApprover(approver);
                setApprovers(approvers);
                setFileList(fileList);
                if (ccUsers) {
                    setCcUsers(ccUserFormStorage.map((user) => ({ value: user.UserId, text: user.Name })));
                }
                if (hasSignSubmit) {
                    setLoadingAssign(true);
                    const assigneeIds = pageActionData === null || pageActionData === void 0 ? void 0 : pageActionData.assigneeIds;
                    postApprovalSign({ ...pageActionData, assigneeIds }, { callWedaApi }).then((res) => {
                        if (res === null || res === void 0 ? void 0 : res.status) {
                            setLoadingAssign(false);
                            sessionStorage.removeItem('FlowActionsMobile');
                            sessionStorage.removeItem('hasSignSubmit');
                            location.reload();
                        }
                    });
                }
            }
        }
    }, [userSelectModelVisible]);
    const onUserSelectModelVisibleChange = () => {
        setUserSelectModelVisible(!userSelectModelVisible);
    };
    const onShowMoreVisibleChange = () => {
        setShowMoreAction(!showMoreAction);
    };
    const onUserSelectModalInfoChange = ({ approveField, mode }) => {
        setUserSelectApproveField(approveField);
        setUserSelectMode(mode);
    };
    return {
        showMoreAction,
        userSelectModelVisible,
        userSelectApproveField,
        userSelectMode,
        approver,
        approvers,
        fileList,
        opinionUserMap,
        highlightPositionMap,
        loadingAssign,
        setUserSelectModelVisible,
        setFileList,
        setApprovers,
        setApprover,
        setOpinionUserMap,
        setHighlightPositionMap,
        onShowMoreVisibleChange,
        onUserSelectModelVisibleChange,
        onUserSelectModalInfoChange,
    };
};
