import React from 'react';
import { PAGE_TYPE } from '../../constants';
import { createModuleFrame } from '../../frame';
import './index.less';
const ModelFlowLayout = (props) => {
    const { flowLocalProps, ide } = props;
    const { isWedaIde, currentPageType } = flowLocalProps;
    const { flowContentSlot, flowControlSlot, ...rest } = ide;
    /**
     * 是否隐藏流程Tab
     * @description 初始化情况下，流程基本信息、流程流转记录、流程图示三个组件
     * 会放到一个Tab组件中，特定条件下会启用该配置。如组件被拆分，改配置将失效
     */
    const hideFlowTab = !isWedaIde && [PAGE_TYPE.CREATEFLOW, PAGE_TYPE.DRAFT].includes(currentPageType);
    return (React.createElement("div", { ...rest, className: "model-flow-layout" },
        React.createElement("div", null, hideFlowTab ? null : React.createElement("div", null, flowContentSlot)),
        React.createElement("div", null, flowControlSlot)));
};
export default createModuleFrame(ModelFlowLayout, 'flow-layout');
