import React from 'react';
import { Tag, Bubble } from 'tea-component';
import { STATUS_TEXT } from '../../../constants';
export const getStatusStr = (status) => {
    const { theme, text } = (STATUS_TEXT === null || STATUS_TEXT === void 0 ? void 0 : STATUS_TEXT[status]) || {};
    if (text) {
        return (React.createElement(Tag, { className: "approval-progress__status", theme: theme }, text));
    }
    return null;
};
export const showTwoUserList = (operatorName, approvalStrategy) => {
    if (typeof operatorName === 'string') {
        return operatorName || '-';
    }
    if (Array.isArray(operatorName)) {
        const names = operatorName.filter((name) => name);
        if (!names.length) {
            return '-';
        }
        if (names.length < 2) {
            return names[0];
        }
        return (React.createElement(Bubble, { arrowPointAtCenter: true, placement: "top-end", content: names.join('、') }, names === null || names === void 0 ? void 0 :
            names.slice(0, 2).join('、'),
            React.createElement("span", null,
                "\u7B49",
                React.createElement("span", { style: { color: '#2473f2' } },
                    names.length,
                    "\u4EBA"),
                approvalStrategy === '1' ? '任签' : '加签')));
    }
};
