const transKey = (str, method) => {
    const firstChar = method === 'toLowerCase' ? str.charAt(0).toLowerCase() : str.charAt(0).toUpperCase();
    return `${firstChar}${str.slice(1)}`;
};
const isArray = (value) => Array.isArray(value);
const isObject = (value) => Object.prototype.toString.call(value) === '[object Object]';
/**
 * 将对象的key的首字母转换为大写或者小写
 */
export function toTransKeyCase(target, method, ignoreKeyValue) {
    const result = {};
    if (isArray(target)) {
        return target === null || target === void 0 ? void 0 : target.map((item) => toTransKeyCase(item, method));
    }
    if (isObject(target)) {
        return Object.keys(target).reduce((acc, key) => {
            const finalKey = transKey(key, method);
            acc[finalKey] = ignoreKeyValue && ignoreKeyValue === key ? target[key] : toTransKeyCase(target[key], method);
            return acc;
        }, result);
    }
    return target;
}
