import React from 'react';
import { Modal, Text, useClassNames } from 'tea-component';
import { FlowChart } from '../FlowChart';
import { Variable } from '../../constants';
export const FlowModal = (props) => {
    const { onClose, visible, ProcessInstanceId, title } = props || {};
    const { Margin } = useClassNames();
    return (React.createElement(Modal, { visible: visible, size: "90%", className: `${Variable}-modal--approval`, caption: React.createElement(React.Fragment, null,
            React.createElement("i", { className: `${Variable}-icon ${Variable}-icon--approval` }),
            React.createElement(Text, { theme: "text", className: Margin.Left['2n'], verticalAlign: "middle" }, title)), onClose: onClose },
        React.createElement(Modal.Body, { style: { backgroundColor: '#f3f4f7' } },
            React.createElement(FlowChart, { instanceid: ProcessInstanceId, processname: title, style: { height: '100%', overflow: 'hidden' } }))));
};
