import React, { useState } from 'react';
import { Button, useClassNames, Modal } from 'tea-component';
import { getRevokeTask } from '../../services';
import { useFlowContext } from './Context';
export const FlowRevokeModal = ({ isRenderRevoke, ProcessInstanceId, doAfterSubmit }) => {
    const [loading, setLoading] = useState(false);
    const { Margin } = useClassNames();
    const { callWorkflow, showError, showToast } = useFlowContext();
    const callEnd = () => {
        setLoading(false);
        close();
        doAfterSubmit();
    };
    // 撤回确定
    const handleRevokeSubmit = async () => {
        try {
            setLoading(true);
            await getRevokeTask({ ProcessInstanceId }, callWorkflow, showToast);
            callEnd();
        }
        catch (error) {
            callEnd();
            showError(error);
        }
    };
    const [visible, setVisible] = useState(false);
    const open = () => setVisible(true);
    const close = () => setVisible(false);
    if (isRenderRevoke) {
        return (React.createElement(React.Fragment, null,
            React.createElement(Button, { type: "error", className: Margin.Right['2n'], onClick: open }, "\u64A4\u56DE"),
            React.createElement(Modal, { visible: visible, onClose: close, disableCloseIcon: true },
                React.createElement(Modal.Body, null,
                    React.createElement("h3", { className: "tea-dialog__messagetitle" }, "\u786E\u5B9A\u8981\u64A4\u56DE\u6B64\u6D41\u7A0B\uFF1F")),
                React.createElement(Modal.Footer, null,
                    React.createElement(Button, { type: "primary", loading: loading, onClick: handleRevokeSubmit }, "\u64A4\u56DE"),
                    React.createElement(Button, { type: "weak", onClick: close }, "\u53D6\u6D88")))));
    }
    return null;
};
