import React, { memo, useContext } from 'react';
import { Handle, Position } from 'react-flow-renderer';
import { Button, Bubble, Text } from 'tea-component';
import { FlowContext } from '../index';
import { FLOW_NODE_STATUS_APPROVE, FLOW_NODE_STATUS_REJECT, FLOW_NODE_STATUS_UNEXECUTED, } from '../constants';
const sourceHandleStyle = {
    backgroundColor: '#fff',
    borderColor: '#999999',
    pointerEvents: 'none',
};
const sourceHandleExcutedStyle = {
    backgroundColor: '#fff',
    borderColor: '#006eff',
    pointerEvents: 'none',
};
// 隐藏线头的端点
const targetHandleStyle = {
    opacity: 0,
    pointerEvents: 'none',
};
// 操作数据表节点
const EditDataTableNode = ({ ...restProps }) => {
    const { flowData } = useContext(FlowContext);
    const { id } = restProps;
    const data = (flowData === null || flowData === void 0 ? void 0 : flowData.find((item) => item.id === id)) || {};
    const { status } = data;
    const { DatasourceExtension: { DatasourceName: initDatasourceName, ExtensionElementName: initExtensionElementName, }, } = (data === null || data === void 0 ? void 0 : data.AutoServiceNode) || { DatasourceExtension: {} };
    const DName = initDatasourceName;
    const EName = initExtensionElementName;
    return (React.createElement("div", { style: { opacity: !status || status === FLOW_NODE_STATUS_UNEXECUTED ? 0.5 : 1 } },
        React.createElement(Handle, { type: "target", position: Position.Top, id: "stop", style: targetHandleStyle }),
        React.createElement("div", { className: "flow-workflow flow-workflow--approval" },
            React.createElement("div", { className: "flow-workflow__inner" },
                React.createElement("div", { className: "flow-workflow__icon" },
                    React.createElement("i", { className: "flow-icon flow-icon--editDataTable" }),
                    React.createElement("div", { className: "flow-workflow__icon-media" },
                        React.createElement("div", { className: "flow-workflow__icon-media--title" },
                            React.createElement(Text, { style: { cursor: 'pointer' }, overflow: true }, "\u64CD\u4F5C\u6570\u636E\u8868")))),
                React.createElement("div", { className: "flow-workflow__form" },
                    React.createElement("div", { className: "flow-workflow__form-item" },
                        React.createElement("div", { className: "flow-workflow__form-item--label" }, "\u5173\u8054\u6570\u636E\u6E90"),
                        React.createElement("div", { className: "flow-workflow__form-item--main-editDataTable" },
                            React.createElement(Button, { type: "text" }, DName ? (React.createElement(Bubble, { content: DName },
                                React.createElement(Text, { style: { cursor: 'pointer' }, overflow: true }, DName))) : (React.createElement(Text, { overflow: true }, "\u672A\u8BBE\u7F6E"))))),
                    React.createElement("div", { className: "flow-workflow__form-item" },
                        React.createElement("div", { className: "flow-workflow__form-item--label" }, "\u64CD\u4F5C\u7C7B\u578B"),
                        React.createElement("div", { className: "flow-workflow__form-item--main-editDataTable" },
                            React.createElement(Button, { type: "text" }, EName ? (React.createElement(Bubble, { content: EName },
                                React.createElement(Text, { style: { cursor: 'pointer' }, overflow: true }, EName))) : (React.createElement(Text, { overflow: true }, "\u672A\u8BBE\u7F6E")))))))),
        React.createElement(Handle, { type: "source", position: Position.Bottom, id: "start", 
            // @ts-ignore
            style: status === FLOW_NODE_STATUS_APPROVE || status === FLOW_NODE_STATUS_REJECT
                ? sourceHandleExcutedStyle
                : sourceHandleStyle })));
};
export default memo(EditDataTableNode);
