import React, { memo, useContext } from 'react';
import { Handle, Position } from 'react-flow-renderer';
import { FlowContext } from '../index';
import { FLOW_NODE_STATUS_UNEXECUTED } from '../constants';
// 隐藏线头的端点
const targetHandleStyle = {
    opacity: 0,
    pointerEvents: 'none',
};
// 结束节点
const EndNode = ({ ...restProps }) => {
    const { flowData } = useContext(FlowContext);
    const { id } = restProps;
    const { status } = (flowData === null || flowData === void 0 ? void 0 : flowData.find((item) => item.id === id)) || {};
    return (React.createElement("div", { style: { opacity: !status || status === FLOW_NODE_STATUS_UNEXECUTED ? 0.5 : 1 } },
        React.createElement(Handle, { type: "target", position: Position.Top, id: "stop", 
            // @ts-ignore
            style: targetHandleStyle }),
        React.createElement("div", { className: "flow-workflow flow-workflow--flash" },
            React.createElement("div", { className: "flow-workflow__inner" },
                React.createElement("div", { className: "flow-workflow__icon" },
                    React.createElement("i", { className: "flow-icon flow-icon--flash" }),
                    React.createElement("span", { className: "flow-text" }, "\u7ED3\u675F"))))));
};
export default memo(EndNode);
