import React, { memo, useContext } from 'react';
import { Handle, Position } from 'react-flow-renderer';
import { Button, Bubble, Text } from 'tea-component';
import { FlowContext } from '../index';
import { FLOW_NODE_STATUS_APPROVE, FLOW_NODE_STATUS_REJECT, FLOW_NODE_STATUS_UNEXECUTED, } from '../constants';
const sourceHandleStyle = {
    backgroundColor: '#fff',
    borderColor: '#999999',
    pointerEvents: 'none',
};
const sourceHandleExcutedStyle = {
    backgroundColor: '#fff',
    borderColor: '#006eff',
    pointerEvents: 'none',
};
// 隐藏线头的端点
const targetHandleStyle = {
    opacity: 0,
};
// 发送消息节点
const SendMsgNode = ({ ...restProps }) => {
    const { flowData } = useContext(FlowContext);
    const { id } = restProps;
    const data = (flowData === null || flowData === void 0 ? void 0 : flowData.find((item) => item.id === id)) || {};
    const { status } = data;
    const nodeData = data === null || data === void 0 ? void 0 : data.NoticeNode;
    const { MessageTemplateName, MessageReceiverNameList = [], MessageReceiverRoleNameList = [], DatasourceUserFieldList = [], } = nodeData || {};
    const ReceiverNameList = [
        ...DatasourceUserFieldList.reduce((list, data) => {
            list.push(...data === null || data === void 0 ? void 0 : data.UserFieldTitleList);
            return list;
        }, []),
        ...MessageReceiverRoleNameList,
        ...MessageReceiverNameList,
    ];
    return (React.createElement("div", { style: { opacity: !status || status === FLOW_NODE_STATUS_UNEXECUTED ? 0.5 : 1 } },
        React.createElement(Handle, { type: "target", position: Position.Top, id: "stop", style: targetHandleStyle }),
        React.createElement("div", { className: "flow-workflow flow-workflow--sendMsg" },
            React.createElement("div", { className: "flow-workflow__inner" },
                React.createElement("div", { className: "flow-workflow__icon" },
                    React.createElement("i", { className: "flow-icon flow-icon--sendMail" }),
                    React.createElement("div", { className: "flow-workflow__icon-media" },
                        React.createElement("div", { className: "flow-workflow__icon-media--title" },
                            React.createElement(Text, { style: { cursor: 'pointer' }, overflow: true }, "\u53D1\u9001\u901A\u77E5")))),
                React.createElement("div", { className: "flow-workflow__form" },
                    React.createElement("div", { className: "flow-workflow__form-item" },
                        React.createElement("div", { className: "flow-workflow__form-item--label" }, "\u901A\u77E5\u6A21\u7248"),
                        React.createElement("div", { className: "flow-workflow__form-item--main" },
                            React.createElement(Button, { type: "text" }, MessageTemplateName ? (React.createElement(Bubble, { content: MessageTemplateName },
                                React.createElement(Text, { style: { cursor: 'pointer' }, overflow: true }, MessageTemplateName))) : (React.createElement(Text, { overflow: true }, "\u672A\u8BBE\u7F6E"))))),
                    React.createElement("div", { className: "flow-workflow__form-item" },
                        React.createElement("div", { className: "flow-workflow__form-item--label" }, "\u901A\u77E5\u4EBA"),
                        React.createElement("div", { className: "flow-workflow__form-item--main" },
                            React.createElement(Button, { type: "text" }, (ReceiverNameList === null || ReceiverNameList === void 0 ? void 0 : ReceiverNameList.length) ? (React.createElement(Bubble, { content: ReceiverNameList.join() },
                                React.createElement(Text, { style: { cursor: 'pointer' }, overflow: true }, ReceiverNameList.join() || '未设置'))) : (React.createElement(Text, { overflow: true }, "\u672A\u8BBE\u7F6E")))))))),
        React.createElement(Handle, { type: "source", position: Position.Bottom, id: "start", 
            // @ts-ignore
            style: status === FLOW_NODE_STATUS_APPROVE || status === FLOW_NODE_STATUS_REJECT
                ? sourceHandleExcutedStyle
                : sourceHandleStyle })));
};
export default memo(SendMsgNode);
