import React, { memo, useContext } from 'react';
import { Handle, Position } from 'react-flow-renderer';
import { FlowContext } from '../index';
import { Bubble, Text } from 'tea-component';
import { FLOW_NODE_STATUS_APPROVE, FLOW_NODE_STATUS_REJECT, FLOW_NODE_STATUS_UNEXECUTED, } from '../constants';
const sourceHandleStyle = {
    backgroundColor: '#fff',
    borderColor: '#999999',
    pointerEvents: 'none',
};
const sourceHandleExcutedStyle = {
    backgroundColor: '#fff',
    borderColor: '#006eff',
};
const targetHandleStyle = {
    opacity: 0,
};
// 单侧分支节点
const SingleNode = ({ ...restProps }) => {
    const { flowData } = useContext(FlowContext);
    const { id } = restProps;
    const { status, ConditionShowName: initConditionName } = (flowData === null || flowData === void 0 ? void 0 : flowData.find((item) => item.id === id)) || {};
    return (React.createElement("div", { style: { opacity: !status || status === FLOW_NODE_STATUS_UNEXECUTED ? 0.5 : 1 } },
        React.createElement(Handle, { type: "target", position: Position.Top, id: "stop", style: targetHandleStyle }),
        React.createElement("div", { className: "flow-workflow flow-workflow--merge" },
            React.createElement("div", { className: "flow-workflow__inner" },
                React.createElement("div", { className: "flow-workflow__icon" },
                    React.createElement("i", { className: "flow-icon flow-icon--merge" }),
                    React.createElement("div", { className: "flow-workflow__icon-media" },
                        React.createElement("div", { className: "flow-workflow__icon-media--title" }, "\u5206\u652F\u8282\u70B9"),
                        React.createElement("div", { className: "flow-workflow__icon-media--des" }, initConditionName ? (React.createElement(Bubble, { content: React.createElement("div", { style: { whiteSpace: 'pre-line' } }, initConditionName) },
                            React.createElement(Text, { style: { cursor: 'pointer' }, overflow: true }, initConditionName))) : (React.createElement(Text, { overflow: true, style: { color: 'rgba(0, 0, 0, 0.25)' } }, "\u6240\u6709\u6570\u636E\u53EF\u8FDB\u5165\u8BE5\u5206\u652F"))))))),
        React.createElement(Handle, { type: "source", position: Position.Bottom, id: "start", style: status === FLOW_NODE_STATUS_APPROVE || status === FLOW_NODE_STATUS_REJECT
                ? sourceHandleExcutedStyle
                : sourceHandleStyle })));
};
export default memo(SingleNode);
