import React, { memo, useContext } from 'react';
import { Handle, Position } from 'react-flow-renderer';
import { FlowContext } from '../index';
import { FLOW_NODE_STATUS_APPROVE, FLOW_NODE_STATUS_REJECT, FLOW_NODE_STATUS_UNEXECUTED, } from '../constants';
const sourceHandleStyle = {
    backgroundColor: '#fff',
    borderColor: '#999999',
    pointerEvents: 'none',
};
const sourceHandleExcutedStyle = {
    backgroundColor: '#fff',
    borderColor: '#006eff',
};
// 触发节点
const TriggerNode = ({ ...restProps }) => {
    const { flowData } = useContext(FlowContext);
    const { id } = restProps;
    const { status } = (flowData === null || flowData === void 0 ? void 0 : flowData.find((item) => item.id === id)) || {};
    return (React.createElement(React.Fragment, null,
        React.createElement("div", { className: "flow-workflow_empty" }),
        React.createElement("div", { className: "flow-workflow flow-workflow--start", style: { opacity: !status || status === FLOW_NODE_STATUS_UNEXECUTED ? 0.5 : 1 } },
            React.createElement("div", { className: "flow-workflow__inner" },
                React.createElement("div", { className: "flow-workflow__icon" },
                    React.createElement("i", { className: "flow-icon flow-icon--start" }),
                    React.createElement("span", { className: "flow-text" }, "\u5F00\u59CB")))),
        React.createElement(Handle, { type: "source", position: Position.Bottom, id: "start", style: status === FLOW_NODE_STATUS_APPROVE || status === FLOW_NODE_STATUS_REJECT
                ? sourceHandleExcutedStyle
                : sourceHandleStyle })));
};
export default memo(TriggerNode);
