/**
 * 流程状态选项
 */
export const FLOW_STATUS: {
    0: string;
    1: string;
    2: string;
    3: string;
    4: string;
};
/**
 * 流程类型-单侧分支
 */
export const FLOW_BRANCHTYPE_SINGLE: "single";
/**
 * 流程类型-汇聚分支起点
 */
export const FLOW_BRANCHTYPE_MULTI_START: "multi_start";
/**
 * 流程类型-汇聚分支终点
 */
export const FLOW_BRANCHTYPE_MULTI_END: "multi_end";
/**
 * 流程节点-审批节点
 */
export const FLOW_TRIGGER_NODE: "triggerNode";
/**
 * 流程节点-审批节点
 */
export const FLOW_APPROVAL_NODE: "approvalNode";
/**
 * 流程节点-单侧节点
 */
export const FLOW_SINGLE_NODE: "singleNode";
/**
 * 流程节点-汇聚节点
 */
export const FLOW_MULTI_BRANCH_NODE: "multiBranchNode";
/**
 * 流程节点-编辑数据表节点
 */
export const FLOW_EDIT_DATA_TABLE_NODE: "editDataTableNode";
/**
 * 流程节点-发送消息节点
 */
export const FLOW_SEND_MSG_NODE: "sendMsgNode";
/**
 * 流程节点-结束节点
 */
export const FLOW_END_NODE: "endNode";
/**
 * 流程节点-空节点
 */
export const FLOW_BLANK_NODE: "blankNode";
/**
 * 流程节点-网关节点
 */
export const FLOW_GATEWAY_NODE: "gatewayNode";
/**
 * 后台bpmn节点-触发时机
 */
export const FLOW_BPMN_TRIGGER_NODE: "ServiceTriggerTask";
/**
 * 后台bpmn节点-审批节点
 */
export const FLOW_BPMN_APPROVAL_NODE: "UserTask";
/**
 * 后台bpmn节点- 结束节点
 */
export const FLOW_BPMN_END_NODE: "EndEvent";
/**
 * 后台bpmn节点- 操作数据表节点
 */
export const FLOW_BPMN_EDIT_DATA_TABLE_NODE: "ServiceTask";
/**
 * 后台bpmn节点- 发送通知节点
 */
export const FLOW_BPMN_SEND_MSG_NODE: "MessageServiceTask";
/**
 * 后台bpmn节点- 排他网关节点
 */
export const FLOW_BPMN_EXCLUSIVE_GATEWAY_NODE: "ExclusiveGateway";
/**
 * 后台bpmn节点- 空事件节点
 */
export const FLOW_BPMN_BLANK_NODE: "NoneServiceTask";
/**
 * 节点状态- 已审批
 */
export const FLOW_NODE_STATUS_APPROVE: "APPROVE";
/**
 * 节点状态- 已驳回
 */
export const FLOW_NODE_STATUS_REJECT: "REJECT";
/**
 * 节点状态- 执行中
 */
export const FLOW_NODE_STATUS_EXECUTING: "EXECUTING";
/**
 * 节点状态- 未执行
 */
export const FLOW_NODE_STATUS_UNEXECUTED: "UNEXECUTED";
/**
 * 流程图布局方向
 * TB:从上到下
 * LR:从左向右
 */
export const FLOW_LAYOUT_DIRECTION: "TB";
/**
 * 流程节点间距
 */
export const FLOW_LAYOUT_NODE_SEP: 200;
/**
 * 流程节点宽度
 */
export const FLOW_LAYOUT_NODE_WIDTH: 130;
/**
 * 流程节点高度
 */
export const FLOW_LAYOUT_NODE_HEIGHT: 100;
/**
 * 流程节点初始宽度
 */
export const FLOW_LAYOUT_NODE_WIDTH_DEFAULT: 130;
/**
 * 流程节点初始高度
 */
export const FLOW_LAYOUT_NODE_HEIGHT_DEFAULT: 120;
/**
 * 流程图背景色
 */
export const FLOW_BACKGROUND_COLOR: "#f3f4f7";
/**
 * 默认缩放比率
 */
export const FLOW_ZOOM_DEFAULT: 1;
/**
 * 最小缩放比率
 */
export const FLOW_ZOOM_MIN: 0.01;
/**
 * 最大缩放比率
 */
export const FLOW_ZOOM_MAX: 10;
export namespace FLOW_BPMN_TO_ELEMENT_TYPE {
    export { FLOW_TRIGGER_NODE as ServiceTriggerTask };
    export { FLOW_END_NODE as EndEvent };
    export { FLOW_APPROVAL_NODE as UserTask };
    export { FLOW_EDIT_DATA_TABLE_NODE as ServiceTask };
    export { FLOW_SEND_MSG_NODE as MessageServiceTask };
    export { FLOW_GATEWAY_NODE as ExclusiveGateway };
    export { FLOW_BLANK_NODE as NoneServiceTask };
}
/**
 * 流程模拟数据
 */
export const FLOW_DEFAULT_DATA: ({
    id: string;
    type: string;
    source?: undefined;
    target?: undefined;
} | {
    id: string;
    source: string;
    target: string;
    type?: undefined;
})[];
