import React from 'react';
import { DatePicker, TimePicker } from 'tea-component';
import moment from 'moment';
import { formatNumberToStr, formatTimeToNumber } from '../../utils/date';
/**
 * 日期组件
 */
export const IDatePicker = (props) => {
    const { format, value, onChange } = props;
    const showTime = format === 'datetime';
    return (React.createElement(DatePicker, { showTime: showTime, disabled: props === null || props === void 0 ? void 0 : props.field['x-powerDisabled'], value: value ? moment(value) : value, onChange: (value) => {
            onChange(value && value.valueOf());
        } }));
};
/**
 * 时间组件
 */
export const ITimePicker = ({ value, onChange }) => {
    let currentTime = null;
    try {
        const timeStr = formatNumberToStr(value);
        currentTime = moment(timeStr, 'HH:mm:ss');
    }
    catch (e) { }
    const handleChange = (time) => {
        try {
            const timeValue = formatTimeToNumber(time);
            onChange(timeValue);
        }
        catch (e) { }
    };
    if ((currentTime === null || currentTime === void 0 ? void 0 : currentTime.toString()) === 'Invalid date') {
        currentTime = null;
    }
    return React.createElement(TimePicker, { value: currentTime, onChange: handleChange });
};
