import React from 'react';
import { Select, Icon } from 'tea-component';
import { useEnumContext } from '../../context';
// 枚举输入组件
export const EnumSelect = (props) => {
    const { field, onChange } = props;
    const { enumOptions } = useEnumContext();
    const optionName = field['x-option-name'];
    const isMulti = field['x-multi-select'];
    const selectProps = {
        options: (enumOptions === null || enumOptions === void 0 ? void 0 : enumOptions[optionName]) || [],
        ...props,
        virtual: true,
        size: 'full',
        matchButtonWidth: true,
        appearance: 'button',
        clearable: true,
        searchable: true,
        staging: false,
    };
    const onSelectChange = (value) => {
        if (onChange) {
            onChange(value || '');
        }
    };
    if (isMulti) {
        return React.createElement(Select.Multiple, { ...selectProps });
    }
    return React.createElement(Select, { ...selectProps, onChange: onSelectChange });
};
// 转换枚举值
export const formatEnum = (value, field, enumOptions) => {
    var _a;
    try {
        const optionName = field['x-option-name'];
        const isMulti = field['x-multi-select'];
        const options = (enumOptions === null || enumOptions === void 0 ? void 0 : enumOptions[optionName]) || [];
        const getTextByValue = (value) => { var _a; return ((_a = options === null || options === void 0 ? void 0 : options.find((item) => (item === null || item === void 0 ? void 0 : item.value) === value)) === null || _a === void 0 ? void 0 : _a.text) || value; };
        if (isMulti) {
            return (_a = []
                .concat(value)
                .map((v) => getTextByValue(v))) === null || _a === void 0 ? void 0 : _a.join();
        }
        return getTextByValue(value);
    }
    catch (e) { }
    return value;
};
// 枚举值展示组件
export const EnumView = (props) => {
    const { field, values } = props;
    const { enumOptions, loading } = useEnumContext();
    if (loading)
        return React.createElement(Icon, { type: "loading" });
    return formatEnum(values, field, enumOptions);
};
