import React from 'react';
import { Select, UserTreeSelect, DepartTreeSelect } from '@cloudbase/weda-ui';
import './Select.css';
/**
 * 地区选择组件
 */
export const IFormSelect = (props) => {
    const { field, onChange, value } = props;
    const regionTypeMap = { 0: 'levelOne', 1: 'levelTwo', 2: 'levelThree' };
    const selectProps = {
        ...props,
        mode: 'mutiRegion',
        regionType: regionTypeMap[field['x-area-code-type'] || 0],
        disableTypeSwitch: true,
        labelVisible: false,
        defaultMutiRegion: value,
        decorator: null,
    };
    const onSelectChange = (value) => {
        if (onChange) {
            onChange(value || '');
        }
    };
    return (React.createElement("div", { className: 'model-region-input' },
        React.createElement(Select, { ...selectProps, onChange: onSelectChange })));
};
/**
 * 用户选择组件
 */
export const IUserSelect = (props) => {
    const { field, onChange, value } = props;
    const selectProps = {
        ...props,
        labelVisible: false,
        defaultValue: value,
        decorator: null,
    };
    const onUserSelectChange = (value) => {
        if (onChange) {
            onChange(value || '');
        }
    };
    return (React.createElement("div", { className: 'model-userDepart-select' },
        React.createElement(UserTreeSelect, { ...selectProps, onChange: onUserSelectChange })));
};
/**
 * 部门选择组件
 */
export const IDepartSelect = (props) => {
    const { field, onChange, value } = props;
    const selectProps = {
        ...props,
        labelVisible: false,
        defaultValue: value
    };
    const onDepartSelectChange = (value) => {
        if (onChange) {
            onChange(value || '');
        }
    };
    return (React.createElement("div", { className: 'model-userDepart-select' },
        React.createElement(DepartTreeSelect, { ...selectProps, onChange: onDepartSelectChange })));
};
