import React from 'react';
import { Layout, Card, ConfigProvider } from 'tea-component';
import './index.less';
const { Body, Content } = Layout;
/**
 * 页面基本布局组件
 */
export function PageLayout(props) {
    const { title, contentSlot, operation, showBackButton, dbName, ...rest } = props || {};
    return (React.createElement(ConfigProvider, { classPrefix: "wedatea2td" },
        React.createElement(Layout, { style: { minHeight: 'calc(100vh - 52px)' }, ...rest },
            React.createElement(Body, null,
                React.createElement(Content, null,
                    React.createElement(Content.Header, { className: "pagelayout-header", title: title, operation: operation, showBackButton: Boolean(showBackButton), onBackButtonClick: (e) => {
                            e === null || e === void 0 ? void 0 : e.preventDefault();
                            window === null || window === void 0 ? void 0 : window.history.back();
                        } }),
                    React.createElement(Content.Body, null,
                        React.createElement(Card, null,
                            React.createElement(Card.Body, null, contentSlot))))))));
}
