import React from 'react';
import { Card } from 'tea-component';
import './index.less';
export default ({ children, align, itemStyle, ...props }) => {
    const childNodes = toArray(children, { keepEmpty: true });
    const nodes = childNodes.map((child, i) => (React.createElement("div", { key: i, className: "space-item" }, child)));
    let className = 'space';
    if (align === 'center') {
        className += ' center';
    }
    return (React.createElement("div", { ...props, className: `${className} ${props.className}` }, nodes));
};
/**
 * react children to array
 *
 */
function toArray(children, option = {}) {
    let ret = [];
    React.Children.forEach(children, (child) => {
        if ((child === undefined || child === null) && !option.keepEmpty) {
            return;
        }
        if (Array.isArray(child)) {
            ret = ret.concat(toArray(child));
        }
        else {
            ret.push(child);
        }
    });
    return ret;
}
/**
 * 标题组件
 */
export const Title = ({ children, ...rest }) => {
    return (React.createElement(Card.Body, { title: React.createElement("div", { className: "space-title" }, children), style: { padding: 0, marginTop: 18 } }));
};
