/**
 * 根据类型获取展示字段组件的 render 方法，用于表格/详情中的值转换
 * extra: { modelType: 'list' | 'detail' | 'update' | 'create', showTip: boolean }
 * 表格中的字符串/枚举数组，详情中的字符串数组会截断并showTip
 */
export function getFieldRender(field?: {}, extra?: {}): (val: any) => JSX.Element | "-";
export function DataItemView({ fields, modelType, value }: {
    fields: any;
    modelType: any;
    value: any;
}): JSX.Element;
export function DataTableView({ fields, value }: {
    fields: any;
    value: any;
}): JSX.Element;
export function formatNumber(value: any, field: any): any;
export function formatBoolean(value: any, field: any): any;
export function formatLocationData(location: any): {
    meta: {
        address: any;
        longitude: any;
        latitude: any;
    };
    flatContent: string;
};
export function formatNumberFix(val: any, field: any, setZero?: boolean): any;
export function getColumns(fields: any, isH5: any): any;
export function formatFieldToColumn(field: any, isH5: any): {
    width: number;
    render: (record: any) => JSX.Element;
    key: any;
    header: any;
    align: string;
    fixed: string;
};
export function getFieldWidth(field: any): number;
export function isProcessHoldOrLocked(processHold: [string], lock: [string]): boolean;
export function isShowOrgsView(field: any, modelType: any): boolean;
export function formatDataToExport(datas: any, fields: any, enumOptions?: {}): any;
export function formatDataToXlsx(datas: any, fields: any, enumOptions?: {}): any[];
export function getSearchAttributes(fields: any): any;
export function getFieldValue(name: any, record: any): any;
export function filterCustomColumns({ columns, columnSets, slots, isH5 }: {
    columns: any;
    columnSets: any;
    slots: any;
    isH5: any;
}): any;
export function filterCustomFields({ fields, columnSets, isFilterGenre }: {
    fields: any;
    columnSets: any;
    isFilterGenre?: boolean;
}): any[];
export function getFixedColumnSets({ fixedFront, fixedEnd, columnSets }: {
    fixedFront?: string;
    fixedEnd?: string;
    columnSets: any;
}): any;
