import React, { Fragment, useState } from 'react';
import { Button, Modal } from 'tea-component';
/**
 * 引用类型显示弹窗
 * @description 使用组件方式编写，避免数据流中断
 */
export const QuoteModal = ({ children, ...restProps }) => {
    const [visible, setVisible] = useState(false);
    const onHandleModalVisible = () => {
        setVisible(!visible);
    };
    return (React.createElement(Fragment, null,
        React.createElement(Button, { onClick: onHandleModalVisible, type: "link" }, "\u8BE6\u60C5"),
        React.createElement(Modal, { ...restProps, visible: visible, onClose: onHandleModalVisible },
            React.createElement(Modal.Body, null, children))));
};
