import useSWR from 'swr';
import { callWedaApi } from '../../../utils';
export function useInOutFieldsRecords({ type, dbName, setIsLodaing }) {
    const actionName = 'DescribeDataImportList';
    const queryParams = {
        action: actionName,
        data: {
            Type: type,
            DataSourceName: dbName,
            PageSize: 1000,
            PageNum: 1,
        },
    };
    const key = dbName + actionName;
    const { data, error } = useSWR(key, async () => {
        setIsLodaing(true);
        const result = await callWedaApi(queryParams);
        setIsLodaing(false);
        return result;
    }, // 8秒dedupe
    { dedupingInterval: 8 * 1000 });
    return { data, isError: error };
}
