import React from 'react';
import { Text, Icon } from 'tea-component';
import { ViewCell } from './ViewCell';
import './dimTreeSelect.less';
export const SelectViewContainer = (props) => {
    const { curSelectItem, placeholder, onChange } = props;
    if (!(curSelectItem === null || curSelectItem === void 0 ? void 0 : curSelectItem.id))
        return React.createElement(Text, { className: "placeholder" }, placeholder);
    return (React.createElement(React.Fragment, null,
        React.createElement(ViewCell, { data: curSelectItem, showType: "tree", relation: undefined }),
        React.createElement(Icon, { type: "dismiss", className: "dim-tree-select__delete-icon", onClick: (e) => {
                e.stopPropagation();
                onChange === null || onChange === void 0 ? void 0 : onChange();
            } })));
};
