import React from 'react';
import { Icon } from 'tea-component';
import { safeJsonParse } from '../../utils';
export const parentIcon = ({ expanded }) => React.createElement(Icon, { type: expanded ? 'folderopen' : 'folderclose' });
// 角色icon
export const roleIcon = () => React.createElement(Icon, { type: 'role' });
// 部门icon
export const departIcon = () => React.createElement(Icon, { type: 'depart' });
// 处理部门数据格式
export const dealOrgData = (data = []) => data.map((i) => ({
    id: `${guidMod(7)}-${i.OrgId}`,
    //   icon: getIcon(i.depth),
    content: i[i.PrimaryColumn],
    children: undefined,
    selectable: true,
    expandable: true,
    icon: parentIcon,
    orgId: i.OrgId,
}));
// 处理角色数据格式
export const dealRoleData = (data = []) => data.map((role) => ({
    id: role.Id,
    expandable: true,
    selectable: false,
    content: role.Name,
    children: undefined,
    icon: parentIcon,
}));
// 处理用户数据格式
export const dealUserData = (data = [], isRole) => data.map((user) => {
    var _a;
    return ({
        id: `${guidMod(7)}-${user.UserId}`,
        expandable: false,
        selectable: true,
        content: (user === null || user === void 0 ? void 0 : user[user === null || user === void 0 ? void 0 : user.PrimaryColumn]) || ((user === null || user === void 0 ? void 0 : user.UserExtend) ? (_a = safeJsonParse(user.UserExtend)) === null || _a === void 0 ? void 0 : _a[user === null || user === void 0 ? void 0 : user.PrimaryColumn] : null),
        userId: user.UserId,
        isUser: true,
        icon: isRole ? roleIcon : departIcon,
    });
});
export function guidMod(bit) {
    const str = 'qwertyuiopasdfghjklmnbvcxz1234567890';
    let cont = '';
    for (let i = 0; i < bit; i++) {
        cont += str[Math.floor(Math.random() * str.length)];
    }
    return cont;
}
export const getNode = (nodes, id, key) => {
    if (!id)
        return null;
    for (const node of nodes) {
        if (node[key] === id) {
            return node;
        }
        if (node.children) {
            const result = getNode(node.children, id, key);
            if (result) {
                return result;
            }
        }
    }
    return null;
};
export const getRelationData = (relation) => {
    var _a, _b;
    const record = (_a = relation === null || relation === void 0 ? void 0 : relation.v1) === null || _a === void 0 ? void 0 : _a.record;
    const primaryColumn = (_b = relation === null || relation === void 0 ? void 0 : relation.v1) === null || _b === void 0 ? void 0 : _b.primaryColumn;
    const data = {
        content: record === null || record === void 0 ? void 0 : record[primaryColumn],
        // eslint-disable-next-line no-underscore-dangle
        id: record === null || record === void 0 ? void 0 : record._id,
    };
    // eslint-disable-next-line no-underscore-dangle
    return data;
};
