export const testFields = [
    {
        name: 'str',
        type: 'string',
        title: '字符串',
        format: '',
        pattern: '',
        minLength: 2,
        'x-required': true,
        description: '描述',
    },
    {
        name: 'num',
        type: 'number',
        title: '数字',
        format: '',
        minimum: 2,
        'x-required': true,
        description: '描述',
    },
    { name: 'bl', type: 'boolean', title: '布尔值', 'x-required': true, description: '描述' },
    {
        name: 'time',
        type: 'number',
        title: '时间',
        format: 'time',
        'x-required': true,
        description: '时间',
    },
    {
        name: 'arr',
        type: 'array',
        items: { type: 'string' },
        title: '数组',
        'x-required': true,
        description: '描述',
    },
    {
        name: 'enum',
        type: 'array',
        items: { type: 'number' },
        title: '枚举',
        'x-enumObj': [
            { label: '开', value: 1, description: '描述' },
            { label: '关', value: 2, description: '描述' },
        ],
        'x-required': true,
        description: '描述',
    },
    {
        name: 'rel',
        type: 'string',
        title: '关联',
        'x-parent': {
            type: 'related',
            parentDsId: 'xxx',
            fatherAction: 'prompt-not-delete',
            parentViewId: 'xxx',
        },
        'x-unique': true,
        'x-required': false,
        description: '关联',
    },
    {
        name: 'rels',
        type: 'array',
        items: {
            type: 'string',
            'x-parent': {
                type: 'related',
                parentDsId: 'xxx',
                fatherAction: 'prompt-not-delete',
                parentViewId: 'xxx',
            },
        },
        title: '关联多选',
        'x-required': false,
        description: '关联',
    },
];
export const testData = [
    {
        _id: 'xxxx',
        str: '测试',
        num: 1000202,
        bl: false,
        time: 1624951802736,
        date: 1624951802736,
        arr: [1, 2, 3],
        enum: 1,
        rel: 'xxxx',
        rels: ['xxxx'],
    },
    {
        _id: 'xxxx2',
        str: '测试',
        num: 1000202,
        bl: false,
        time: 1624951802736,
        date: 1624951802736,
        arr: [1, 2, 3],
        enum: 1,
        rel: 'xxxx',
    },
    {
        _id: 'xxxx3',
        str: '测试',
        num: 1000202,
        bl: false,
        time: 1624951802736,
        date: 1624951802736,
        arr: [1, 2, 3],
        enum: 1,
        rel: 'xxxx',
    },
    {
        _id: 'xxxx4',
        str: '测试',
        num: 1000202,
        bl: false,
        time: 1624951802736,
        date: 1624951802736,
        arr: [1, 2, 3],
        enum: 1,
        rel: 'xxxx',
    },
];
export const testFields2 = [
    {
        name: 'str',
        title: '字符串',
        type: 'string',
        description: '描述',
        format: '',
        pattern: '',
        minLength: 2,
        'x-required': true,
    },
    {
        name: 'num',
        title: '数字',
        type: 'number',
        description: '描述',
        format: '',
        pattern: '',
        minimum: 2,
        'x-required': true,
    },
    {
        name: 'bl',
        title: '布尔值',
        type: 'boolean',
        description: '描述',
        format: '',
        pattern: '',
        'x-required': true,
    },
    {
        name: 'time',
        title: '时间',
        type: 'number',
        description: '时间',
        format: 'time',
        pattern: '',
        'x-required': true,
    },
    // {
    //   title: '对象',
    //   type: 'object',
    //   description: '描述',
    //   format: '',
    //   pattern: '',
    //   'x-required': true,
    //   'x-parent': ''
    // },
    {
        name: 'arr',
        title: '数组',
        type: 'array',
        description: '描述',
        format: '',
        pattern: '',
        'x-required': true,
        items: {
            type: 'string',
        },
    },
    {
        name: 'enum',
        title: '枚举',
        type: 'array',
        description: '描述',
        items: { type: 'number' },
        'x-required': true,
        'x-parent': '',
        'x-enumObj': [
            {
                value: 1,
                label: '开',
                description: '描述',
            },
            {
                value: 2,
                label: '关',
                description: '描述',
            },
        ],
    },
    {
        name: 'rel',
        title: '关联',
        type: 'string',
        description: '关联',
        'x-unique': true,
        'x-required': false,
        'x-parent': {},
    },
    {
        name: 'rels',
        title: '关联多选',
        type: 'array',
        description: '关联',
        items: {
            type: 'string',
        },
        'x-required': false,
        'x-parent': {},
    },
];
