import loadable from '@loadable/component';
import { fallback } from '../utils/loading-fallback';
import 'tea-component/dist/tea.css';
import '../styles/index.less';
export { FlowCard } from './FlowCard';
export { ModelTable } from './Table';
export { ModelDetail } from './Detail';
export { ModelCreate } from './Create';
export { ModelUpdate } from './Update';
export { ApprovalHistory } from './ApprovalHistory';
export { FlowChart } from './FlowChart';
export { PageLayout } from './PageLayout';
export const ModelFlow = loadable(() => import('./Flow/modules/combination'), {
    fallback,
});
export const ModelFlowBasic = loadable(() => import('./Flow/modules/basic'), {
    fallback,
});
export const ModelFlowChart = loadable(() => import('./Flow/modules/chart'), {
    fallback,
});
export const ModelFlowControl = loadable(() => import('./Flow/modules/control'), {
    fallback,
});
export const ModelFlowLayout = loadable(() => import('./Flow/modules/layout'), {
    fallback,
});
export const ModelFlowProcess = loadable(() => import('./Flow/modules/process'), {
    fallback,
});
