export const APPROVAL_COMMENTS = '审批意见';
export const START_EVENT_TEXT = '发起';
export const END_EVENT_TEXT = '流程结束';
export const REJECT_TO = '至';
export const REVOKE_TEXT_MAP = {
    REVOKED: '撤回',
    FLOW: '流程',
};
export const STEP_STATUS_STYLE_MAP = {
    approving: 'warning',
    approved: 'success',
    rejected: 'error',
    termination: 'label',
    turnSign: 'warning',
    backwardSign: 'warning',
    forwardSign: 'warning',
};
export const APPROVER_NODE_STATUS_STYLE_MAP = {
    ...STEP_STATUS_STYLE_MAP,
    rejected: 'danger',
};
export const APPROVER_NODE_STATUS_TEXT_MAP = {
    approving: '等待处理',
    approved: '通过',
    rejected: '驳回',
    termination: '已终止',
    turnSign: '转签',
    backwardSign: '加签',
    forwardSign: '加签',
};
export const FIELD_UPDATE_TEXT_MAP = {
    FROM: '由',
    TO: '更新为',
    FAILED: '异常',
};
export const APPROVAL_TYPE = {
    APPROVE_SINGLE: 'APPROVE_SINGLE',
    APPROVE_MULTI: 'APPROVE_MULTI',
};
export const APPROVAL_TYPE_TEXT_MAP = {
    APPROVE_SINGLE: '单人审批',
    APPROVE_MULTI: '多人会签',
};
export const ELEMENT_TYPE_MAP = {
    START_EVENT: 'StartEvent',
    END_EVENT: 'EndEvent',
    APPROVAL_EVENT: 'ApprovalEvent',
    REVOKE_EVENT: 'RevokeEvent',
};
export const ELEMENT_TYPE_MAP_FOR_COMPONENT = {
    START_EVENT: 'StartEvent',
    END_EVENT: 'EndEvent',
};
export const APPROVAL_STATUS_MAP = {
    APPROVED: 'approved',
    REJECTED: 'rejected',
    APPROVING: 'approving',
    TERMINATION: 'termination',
    TURN_SIGN: 'turnSign',
    BACKWARD_SIGN: 'backwardSign',
    FORWARD_SIGN: 'forwardSign',
    REVOKED: 'revoked',
};
export const COMMENT_TYPE_MAP = {
    APPROVE: 'APPROVED',
    REJECT: 'REJECTED',
    TURN_SIGN: 'TURN_SIGN',
    BACKWARD_SIGN: 'BACKWARD_SIGN',
    FORWARD_SIGN: 'FORWARD_SIGN',
};
export const COMMENT_TYPE = {
    ...COMMENT_TYPE_MAP,
    APPROVE: 'APPROVE',
    REJECT: 'REJECT',
};
export const TRIGGER_FUNC_NAME_MAP = {
    wedaUpdate: '更新',
    wedaDelete: '删除',
    wedaCreate: '新建',
};
export const TRIGGER_TYPE = {
    OPT_DATASOURCE: 'OPT_DATASOURCE',
    SEND_MESSAGE: 'SEND_MESSAGE',
};
export const TRIGGER_TYPE_EVENT_MAP = {
    [TRIGGER_TYPE.OPT_DATASOURCE]: 'DatasourceEvent',
    [TRIGGER_TYPE.SEND_MESSAGE]: 'NoticeEvent',
};
export const TRIGGER_FIELD_METHOD = {
    UPDATE: 'UPDATE',
    CREATE: 'CREATE',
    DELETE: 'DELETE',
    LOCK: 'LOCK',
    UNLOCK: 'UNLOCK',
};
export const TRIGGER_FIELD_METHOD_NAME_MAP = {
    [TRIGGER_FIELD_METHOD.UPDATE]: '更新',
    [TRIGGER_FIELD_METHOD.CREATE]: '新建',
    [TRIGGER_FIELD_METHOD.DELETE]: '删除',
    [TRIGGER_FIELD_METHOD.LOCK]: '锁定',
    [TRIGGER_FIELD_METHOD.UNLOCK]: '解锁',
};
export const TRIGGER_ELEMENT_TYPE_MAP = {
    MessageServiceTask: 'MessageServiceTask',
    ServiceTask: 'ServiceTask',
};
export const TRIGGER_ELEMENT_TYPE_NAME_MAP = {
    [TRIGGER_ELEMENT_TYPE_MAP.MessageServiceTask]: '发送通知',
    [TRIGGER_ELEMENT_TYPE_MAP.ServiceTask]: '操作数据表',
};
