/**
 * 流程上限
 */
export const DATA_FLOW_LIMIT = 20;
/**
 * 流程名称长度上限
 */
export const FLOW_NAME_LIMIT = 30;
/**
 * 流程ID长度上限
 */
export const FLOW_ID_LIMIT = 30;
export const START_EVENT = 'StartEvent'; // 开始节点
export const APPROVAL_NODE_TYPE = 'UserTask'; // 审批节点类型
export const SERVICE_TASK = 'ServiceTask'; // 自动审批节点
export const REJECT_TO_START_NODE = 'REJECT_TO_START_NODE'; // 发起人节点
export const REJECT_TO_LAST_NODE = 'REJECT_TO_LAST_NODE'; // 上一个节点
export const REJECT_TO_ANY_NODE = 'REJECT_TO_ANY_NODE'; // 已运行的任意节点
export const SAME_USER_AS_PREV = 'SAME_USER_AS_PREV'; // 上一个节点的审批人
export const PASS = 'pass'; // 审批通过
export const REJECT = 'reject'; // 审批通过
export const X_ENUM_OBJ = 'x-enumObj'; // 枚举key名称
export const X_REQUIRED = 'x-required'; // 必填
export const Variable = 'flow'; // 组件前缀
export const RESPONSE = 'Response';
export const DATA = 'Data';
export const REJECT_TO = '驳回至';
export const NEXT_APPROVER = '下一步审批人';
export const APPROVAL_MESSAGE = '审批意见';
export const APPROVING = 'APPROVING'; // 审批中
export const SIGN_MESSAGE = '加签意见';
export const TURN_SIGN_MESSAGE = '转签意见';
export const SIGN_TYPE_MAP = {
    FORWARD_SIGN: '前加签',
    BACKWARD_SIGN: '后加签',
    3: '转签',
};
export const APPROVAL_TYPE = {
    // 审批类型
    APPROVE_SINGLE: '单人审批',
    APPROVE_MULTI: '多人会签',
};
export const APPROVAL_STATUS = {
    // 审批状态
    APPROVING: '审批中',
    APPROVED: '已通过',
    APPROVE: '通过',
    REJECTED: '已驳回',
    REJECT: '驳回',
    EXECUTING: '审批中',
    UNEXECUTED: '未执行',
    FAILED: '异常',
    REVOKED: '已撤回',
};
export const APPROVAL_ICON_TYPE = {
    APPROVING: 'pending',
    EXECUTING: 'pending',
    APPROVED: 'success',
    APPROVE: 'success',
    REJECTED: 'error',
    UNEXECUTED: 'pending-gray',
    REJECT: 'error',
    FAILED: 'error',
    REVOKED: 'warning',
};
export const NODE_WRAPPER_CLASS = {
    APPROVING: 'is-warning',
    APPROVED: 'is-success',
    REJECTED: 'is-error',
    FAILED: 'is-error',
    REVOKED: 'is-warning',
};
export const APPROVAL_TEXT_THEME = {
    APPROVING: 'warning',
    EXECUTING: 'warning',
    APPROVED: 'success',
    APPROVE: 'success',
    REJECTED: 'danger',
    UNEXECUTED: 'label',
    REJECT: 'danger',
    FAILED: 'danger',
    REVOKED: 'warning',
};
export const NO_CALLWORKFLOW_TIPS = {
    title: '没有callWorkflow方法',
    icon: 'error',
};
export const NO_CALLWEDAAPI_TIPS = {
    title: '没有callWedaApi方法',
    icon: 'error',
};
