import React, { createContext, useContext } from 'react';
import { appCloudIsInWedaIde, appCloudGetDataSourceProfile, appCloudCallWedaApi, appCloudCallWorkFlow, appCloudShowWedaToast, appCloudGetWedaUserId, appCloudGetWedaRelatedRoles, } from '../../utils';
const Context = createContext({
    IS_WEDA_IDE: false,
    wedaUserId: null,
    wedaRelatedRoles: [],
    getDataSourceByName: () => { },
    callWorkflow: () => { },
    callWedaApi: () => { },
    showToast: () => { },
    showError: () => { },
});
export const Provider = ({ children }) => {
    const showToast = appCloudShowWedaToast;
    // 汇总所有 获取数据的方法与 环境或用户信息， 通过 appCloud提供的Api 进行获取。
    const value = {
        IS_WEDA_IDE: appCloudIsInWedaIde === null || appCloudIsInWedaIde === void 0 ? void 0 : appCloudIsInWedaIde(),
        wedaUserId: appCloudGetWedaUserId === null || appCloudGetWedaUserId === void 0 ? void 0 : appCloudGetWedaUserId(),
        wedaRelatedRoles: appCloudGetWedaRelatedRoles === null || appCloudGetWedaRelatedRoles === void 0 ? void 0 : appCloudGetWedaRelatedRoles(),
        getDataSourceByName: appCloudGetDataSourceProfile,
        callWorkflow: appCloudCallWorkFlow,
        callWedaApi: appCloudCallWedaApi,
        showError: (error) => {
            showToast({
                title: error.message,
                icon: 'error',
            });
            Promise.reject(error);
        },
        showToast,
    };
    return React.createElement(Context.Provider, { value: value }, children);
};
export const useGlobalContext = () => {
    const value = useContext(Context);
    return value;
};
export const globalContextConnect = (WrappedComponent) => (props) => (React.createElement(Provider, null,
    React.createElement(WrappedComponent, { ...props })));
