import { useState, useEffect } from 'react';
export function useMediaQuery(query) {
    const [matches, setMatches] = useState(false);
    useEffect(() => {
        const media = window.matchMedia(query);
        if (media.matches !== matches) {
            setMatches(media.matches);
        }
        const listener = () => setMatches(media.matches);
        if (media === null || media === void 0 ? void 0 : media.addEventListener) {
            media.addEventListener('change', listener);
        }
        else {
            media === null || media === void 0 ? void 0 : media.addListener(listener);
        }
        return () => {
            if (media.removeEventListener) {
                media.removeEventListener('change', listener);
            }
            else if (media.removeListener) {
                media.removeListener(listener);
            }
        };
    }, [matches, query]);
    return matches;
}
