export namespace approvalHistoryMockData {
    const Status: string;
    const ProcessInstanceBeginTime: string;
    const ProcessNodeDetailList: ({
        ProcessNode: {
            Status: string;
            ElementType: string;
            NodeName: string;
            NodeKey: string;
            TriggerNode?: undefined;
            NoticeNode?: undefined;
            AutoServiceNode?: undefined;
            TaskId?: undefined;
            ManualUserNode?: undefined;
            HandledRoleIdList?: undefined;
            HandledDatasourceUserFieldList?: undefined;
        };
        CommentInfoList?: undefined;
    } | {
        ProcessNode: {
            Status: string;
            ElementType: string;
            NodeName: string;
            TriggerNode: {
                TriggerType: string;
                DatasourceExtension: {
                    Datasource: string;
                    TriggerFuncList: string[];
                    OperationOrExpressionList: {
                        OperationAndExtensionList: {
                            Condition: string;
                            KeyType: string;
                            ValueType: string;
                            Value: string;
                            Key: string;
                        }[];
                    }[];
                    ExtensionElementType: string;
                    UpdateFieldList: any[];
                    Namespace: string;
                };
                TriggerCycleType: string;
                StartUser: string;
                EndDate: string;
                BeginDate: string;
                ExecTime: string;
            };
            NodeKey: string;
            NoticeNode?: undefined;
            AutoServiceNode?: undefined;
            TaskId?: undefined;
            ManualUserNode?: undefined;
            HandledRoleIdList?: undefined;
            HandledDatasourceUserFieldList?: undefined;
        };
        CommentInfoList?: undefined;
    } | {
        ProcessNode: {
            Status: string;
            ElementType: string;
            NodeName: string;
            NodeKey: string;
            NoticeNode: {
                MessageTemplateId: string;
                MessageReceiverNameList: string[];
                MessageTemplateName: string;
                MessageReceiverList: string[];
            };
            TriggerNode?: undefined;
            AutoServiceNode?: undefined;
            TaskId?: undefined;
            ManualUserNode?: undefined;
            HandledRoleIdList?: undefined;
            HandledDatasourceUserFieldList?: undefined;
        };
        CommentInfoList: {
            Type: string;
            TaskId: string;
            Message: {
                Text: string;
            };
            Author: string;
            AuthorInfo: {
                UserName: string;
                UserId: string;
            };
            Time: string;
            ProcessInstanceId: string;
            CommentId: string;
        }[];
    } | {
        ProcessNode: {
            Status: string;
            ElementType: string;
            NodeName: string;
            AutoServiceNode: {
                DatasourceExtension: {
                    ExtensionElementName: string;
                    Datasource: string;
                    TriggerFuncList: string[];
                    DatasourceName: string;
                    ViewId: string;
                    ExtensionElementType: string;
                    UpdateFieldList: {
                        KeyType: string;
                        ValueType: string;
                        Value: string;
                        Id: string;
                        Key: string;
                    }[];
                    Namespace: string;
                };
            };
            NodeKey: string;
            TriggerNode?: undefined;
            NoticeNode?: undefined;
            TaskId?: undefined;
            ManualUserNode?: undefined;
            HandledRoleIdList?: undefined;
            HandledDatasourceUserFieldList?: undefined;
        };
        CommentInfoList: {
            Type: string;
            TaskId: string;
            Message: {
                Status: string;
                DatasourceFieldInfoList: ({
                    Method: string;
                    ItemId?: undefined;
                } | {
                    ItemId: string;
                    Method: string;
                })[];
            };
            Author: string;
            AuthorInfo: {
                UserName: string;
                UserId: string;
            };
            Time: string;
            ProcessInstanceId: string;
            CommentId: string;
        }[];
    } | {
        ProcessNode: {
            Status: string;
            ElementType: string;
            TaskId: string;
            NodeName: string;
            NodeKey: string;
            ManualUserNode: {
                NodeName: string;
                ApprovalType: string;
                ApprovalUserType: string;
                ApprovalUserNameList: string[];
                ApprovalUserList: string[];
                ApproveMethodExtension: {
                    ApprovalMethodType: string;
                    ApprovalDatasource: {
                        Datasource: string;
                        DatasourceFieldList: {
                            Required: boolean;
                            Key: string;
                        }[];
                        Namespace: string;
                    };
                    TriggerAfterEventExtensionList: ({
                        TriggerAfterEvent: string;
                        MessageNoticeNode: {
                            MessageTemplateId: string;
                            MessageReceiverList: string[];
                        };
                        DatasourceExtension?: undefined;
                    } | {
                        TriggerAfterEvent: string;
                        DatasourceExtension: {
                            Datasource: string;
                            TriggerFuncList: string[];
                            ExtensionElementType: string;
                            UpdateFieldList: {
                                KeyType: string;
                                ValueType: string;
                                Value: string;
                                Id: string;
                                Key: string;
                            }[];
                            Namespace: string;
                        };
                        MessageNoticeNode?: undefined;
                    })[];
                };
                ApprovalRoleIdList?: undefined;
                ApprovalRoleNameList?: undefined;
                DatasourceUserFieldList?: undefined;
                RejectMethodExtension?: undefined;
            };
            TriggerNode?: undefined;
            NoticeNode?: undefined;
            AutoServiceNode?: undefined;
            HandledRoleIdList?: undefined;
            HandledDatasourceUserFieldList?: undefined;
        };
        CommentInfoList: ({
            CommentId: string;
            Message: {
                Text: string;
                Status?: undefined;
                DatasourceFieldInfoList?: undefined;
            };
            AuthorInfo: {
                UserName: string;
                UserId: string;
            };
            Author: string;
            Type: string;
            Time: string;
            TaskId?: undefined;
            ProcessInstanceId?: undefined;
        } | {
            Type: string;
            TaskId: string;
            Message: {
                Status: string;
                DatasourceFieldInfoList: {
                    SourceValue: string;
                    TargetValue: string;
                    Method: string;
                    ItemId: string;
                    FieldName: string;
                }[];
                Text?: undefined;
            };
            Author: string;
            AuthorInfo: {
                UserName: string;
                UserId: string;
            };
            Time: string;
            ProcessInstanceId: string;
            CommentId: string;
        } | {
            Type: string;
            TaskId: string;
            Message: {
                Text: string;
                Status?: undefined;
                DatasourceFieldInfoList?: undefined;
            };
            Author: string;
            AuthorInfo: {
                UserName: string;
                UserId: string;
            };
            Time: string;
            ProcessInstanceId: string;
            CommentId: string;
        })[];
    } | {
        ProcessNode: {
            Status: string;
            ElementType: string;
            TaskId: string;
            NodeName: string;
            NodeKey: string;
            ManualUserNode: {
                NodeName: string;
                ApprovalType: string;
                ApprovalUserType: string;
                ApprovalUserNameList: string[];
                ApprovalUserList: string[];
                ApproveMethodExtension?: undefined;
                ApprovalRoleIdList?: undefined;
                ApprovalRoleNameList?: undefined;
                DatasourceUserFieldList?: undefined;
                RejectMethodExtension?: undefined;
            };
            TriggerNode?: undefined;
            NoticeNode?: undefined;
            AutoServiceNode?: undefined;
            HandledRoleIdList?: undefined;
            HandledDatasourceUserFieldList?: undefined;
        };
        CommentInfoList: ({
            CommentId: string;
            Message: {
                Text: string;
                RelatedUser?: undefined;
            };
            AuthorInfo: {
                UserName: string;
                UserId: string;
            };
            Author: string;
            Type: string;
            Time: string;
        } | {
            CommentId: string;
            Message: {
                Text: string;
                RelatedUser: {
                    UserName: string;
                    UserId: string;
                };
            };
            AuthorInfo: {
                UserName: string;
                UserId: string;
            };
            Author: string;
            Type: string;
            Time: string;
        })[];
    } | {
        ProcessNode: {
            Status: string;
            ElementType: string;
            TaskId: string;
            NodeName: string;
            NodeKey: string;
            ManualUserNode: {
                NodeName: string;
                ApprovalType: string;
                ApprovalUserType: string;
                ApprovalUserNameList: string[];
                ApprovalUserList: string[];
                ApprovalRoleIdList: number[];
                ApprovalRoleNameList: string[];
                DatasourceUserFieldList: {
                    DatasourceName: string;
                    UserFieldNameList: string[];
                    UserFieldTitleList: string[];
                }[];
                ApproveMethodExtension?: undefined;
                RejectMethodExtension?: undefined;
            };
            HandledRoleIdList: number[];
            HandledDatasourceUserFieldList: {
                DatasourceName: string;
                UserFieldNameList: string[];
                UserFieldTitleList: string[];
            }[];
            TriggerNode?: undefined;
            NoticeNode?: undefined;
            AutoServiceNode?: undefined;
        };
        CommentInfoList: {
            CommentId: string;
            Message: {
                Text: string;
            };
            AuthorInfo: {
                UserName: string;
                UserId: string;
            };
            Author: string;
            Type: string;
            Time: string;
        }[];
    } | {
        ProcessNode: {
            Status: string;
            ElementType: string;
            TaskId: string;
            NodeName: string;
            NodeKey: string;
            ManualUserNode: {
                NodeName: string;
                ApprovalType: string;
                ApprovalUserType: string;
                ApprovalUserNameList: string[];
                ApprovalUserList: string[];
                ApprovalRoleIdList: number[];
                ApprovalRoleNameList: string[];
                RejectMethodExtension: {
                    ApprovalMethodType: string;
                    RejectOptionType: string;
                    ApprovalDatasource: {
                        Datasource: string;
                        Namespace: string;
                    };
                    TriggerAfterEventExtensionList: ({
                        TriggerAfterEvent: string;
                        MessageNoticeNode: {
                            MessageTemplateId: string;
                            MessageReceiverList: string[];
                        };
                        DatasourceExtension?: undefined;
                    } | {
                        TriggerAfterEvent: string;
                        DatasourceExtension: {
                            Datasource: string;
                            TriggerFuncList: string[];
                            ExtensionElementType: string;
                            UpdateFieldList: {
                                KeyType: string;
                                ValueType: string;
                                Value: string;
                                Id: string;
                                Key: string;
                            }[];
                            Namespace: string;
                        };
                        MessageNoticeNode?: undefined;
                    })[];
                };
                DatasourceUserFieldList: {
                    DatasourceName: string;
                    UserFieldNameList: string[];
                    UserFieldTitleList: string[];
                }[];
                ApproveMethodExtension?: undefined;
            };
            HandledRoleIdList: number[];
            HandledDatasourceUserFieldList: {
                DatasourceName: string;
                UserFieldNameList: string[];
                UserFieldTitleList: string[];
            }[];
            TriggerNode?: undefined;
            NoticeNode?: undefined;
            AutoServiceNode?: undefined;
        };
        CommentInfoList: ({
            CommentId: string;
            Message: {
                Text: string;
                Status?: undefined;
                DatasourceFieldInfoList?: undefined;
            };
            AuthorInfo: {
                UserName: string;
                UserId: string;
            };
            Author: string;
            Type: string;
            Time: string;
            TaskId?: undefined;
            ProcessInstanceId?: undefined;
        } | {
            Type: string;
            TaskId: string;
            Message: {
                Status: string;
                DatasourceFieldInfoList: {
                    SourceValue: string;
                    TargetValue: string;
                    Method: string;
                    ItemId: string;
                    FieldName: string;
                }[];
                Text?: undefined;
            };
            Author: string;
            AuthorInfo: {
                UserName: string;
                UserId: string;
            };
            Time: string;
            ProcessInstanceId: string;
            CommentId: string;
        })[];
    })[];
}
