export namespace flowData {
    const ProcessInstanceId: string;
    const ProcessDefinitionId: string;
    const ProcessDefinitionName: string;
    const Status: string;
    const ProcessInstanceBeginTime: string;
    const HistoricApproveNodeCount: number;
    const SequenceFlowList: ({
        FlowKey: string;
        FlowName: string;
        SourceNodeKey: string;
        TargetNodeKey: string;
        DatasourceExtension?: undefined;
    } | {
        FlowKey: string;
        FlowName: string;
        SourceNodeKey: string;
        TargetNodeKey: string;
        DatasourceExtension: {
            ExtensionElementType: string;
            Namespace: string;
            Datasource: string;
            OperationOrExpressionList: {
                OperationAndExtensionList: {
                    Key: string;
                    KeyType: string;
                    Condition: string;
                    Value: string;
                    ValueType: string;
                }[];
            }[];
        };
    })[];
    const ProcessNodeDetailList: ({
        ProcessNode: {
            ElementType: string;
            NodeName: string;
            NodeKey: string;
            Status: string;
            TriggerNode?: undefined;
            ManualUserNode?: undefined;
            TaskId?: undefined;
            AddSignTaskType?: undefined;
        };
        CommentInfoList?: undefined;
    } | {
        ProcessNode: {
            ElementType: string;
            NodeName: string;
            NodeKey: string;
            TriggerNode: {
                RevokeTypeList: string[];
                TriggerType: string;
                BeginDate: string;
                EndDate: string;
                ExecTime: string;
                TriggerCycleType: string;
                StartUser: string;
                StartUserId: string;
                DatasourceExtension: {
                    ExtensionElementType: string;
                    Namespace: string;
                    Datasource: string;
                    TriggerFuncList: string[];
                    OperationOrExpressionList: {
                        OperationAndExtensionList: {
                            Key: string;
                            KeyType: string;
                            Condition: string;
                            Value: string;
                            ValueType: string;
                        }[];
                    }[];
                    UpdateFieldList: any[];
                };
            };
            Status: string;
            ManualUserNode?: undefined;
            TaskId?: undefined;
            AddSignTaskType?: undefined;
        };
        CommentInfoList?: undefined;
    } | {
        ProcessNode: {
            ElementType: string;
            NodeName: string;
            NodeKey: string;
            ManualUserNode: {
                NodeName: string;
                ApprovalType: string;
                ApprovalUserType: string;
                ApprovalUserList: string[];
                ApprovalUserNameList: string[];
                ApproveMethodExtension: {
                    ApprovalMethodType: string;
                    ApprovalDatasource: {
                        Namespace: string;
                        Datasource: string;
                        DatasourceFieldList: {
                            Key: string;
                            Required: boolean;
                        }[];
                    };
                    TriggerAfterEventExtensionList: ({
                        TriggerAfterEvent: string;
                        MessageNoticeNode: {
                            MessageTypeList: number[];
                            MessageReceiverList: string[];
                            MessageTemplateId: string;
                        };
                        DatasourceExtension?: undefined;
                    } | {
                        TriggerAfterEvent: string;
                        DatasourceExtension: {
                            ExtensionElementType: string;
                            Namespace: string;
                            Datasource: string;
                            TriggerFuncList: string[];
                            UpdateFieldList: {
                                Key: string;
                                KeyType: string;
                                Value: string;
                                ValueType: string;
                            }[];
                        };
                        MessageNoticeNode?: undefined;
                    })[];
                };
                RejectMethodExtension: {
                    ApprovalMethodType: string;
                    RejectOptionType: string;
                    ApprovalDatasource: {
                        Namespace: string;
                        Datasource: string;
                        DatasourceFieldList: {
                            Key: string;
                            Required: boolean;
                        }[];
                    };
                    TriggerAfterEventExtensionList: ({
                        TriggerAfterEvent: string;
                        MessageNoticeNode: {
                            MessageTypeList: number[];
                            MessageReceiverList: string[];
                            MessageTemplateId: string;
                        };
                        DatasourceExtension?: undefined;
                    } | {
                        TriggerAfterEvent: string;
                        DatasourceExtension: {
                            ExtensionElementType: string;
                            Namespace: string;
                            Datasource: string;
                            TriggerFuncList: string[];
                            UpdateFieldList: {
                                Key: string;
                                KeyType: string;
                                Value: string;
                                ValueType: string;
                            }[];
                        };
                        MessageNoticeNode?: undefined;
                    })[];
                };
                SignTaskInfo?: undefined;
                DatasourceUserFieldList?: undefined;
                ApprovalRoleIdList?: undefined;
                ApprovalRoleNameList?: undefined;
            };
            Status: string;
            TaskId: string;
            TriggerNode?: undefined;
            AddSignTaskType?: undefined;
        };
        CommentInfoList: {
            CommentId: string;
            Message: {
                Text: string;
            };
            Author: string;
            Type: string;
            Time: string;
            TaskId: string;
            ProcessInstanceId: string;
        }[];
    } | {
        ProcessNode: {
            ElementType: string;
            NodeName: string;
            NodeKey: string;
            ManualUserNode: {
                NodeName: string;
                ApprovalUserType: string;
                ApprovalUserList: string[];
                ApprovalUserNameList: string[];
                ApproveMethodExtension: {
                    ApprovalMethodType: string;
                    ApprovalDatasource: {
                        Namespace: string;
                        Datasource: string;
                        DatasourceFieldList: {
                            Key: string;
                            Required: boolean;
                        }[];
                    };
                    TriggerAfterEventExtensionList: ({
                        TriggerAfterEvent: string;
                        MessageNoticeNode: {
                            MessageTypeList: number[];
                            MessageReceiverList: string[];
                            MessageTemplateId: string;
                        };
                        DatasourceExtension?: undefined;
                    } | {
                        TriggerAfterEvent: string;
                        DatasourceExtension: {
                            ExtensionElementType: string;
                            Namespace: string;
                            Datasource: string;
                            TriggerFuncList: string[];
                            UpdateFieldList: {
                                Key: string;
                                KeyType: string;
                                Value: string;
                                ValueType: string;
                            }[];
                        };
                        MessageNoticeNode?: undefined;
                    })[];
                };
                RejectMethodExtension: {
                    ApprovalMethodType: string;
                    RejectOptionType: string;
                    ApprovalDatasource: {
                        Namespace: string;
                        Datasource: string;
                        DatasourceFieldList: {
                            Key: string;
                            Required: boolean;
                        }[];
                    };
                    TriggerAfterEventExtensionList: ({
                        TriggerAfterEvent: string;
                        MessageNoticeNode: {
                            MessageTypeList: number[];
                            MessageReceiverList: string[];
                            MessageTemplateId: string;
                        };
                        DatasourceExtension?: undefined;
                    } | {
                        TriggerAfterEvent: string;
                        DatasourceExtension: {
                            ExtensionElementType: string;
                            Namespace: string;
                            Datasource: string;
                            TriggerFuncList: string[];
                            UpdateFieldList: {
                                Key: string;
                                KeyType: string;
                                Value: string;
                                ValueType: string;
                            }[];
                        };
                        MessageNoticeNode?: undefined;
                    })[];
                };
                SignTaskInfo: {
                    EnableSignTask: boolean;
                    EnableTurnSign: boolean;
                    SignTaskTypeList: string[];
                };
                DatasourceUserFieldList: {
                    DatasourceName: string;
                    UserFieldNameList: string[];
                    UserFieldTitleList: string[];
                }[];
                ApprovalType?: undefined;
                ApprovalRoleIdList?: undefined;
                ApprovalRoleNameList?: undefined;
            };
            Status: string;
            TaskId: string;
            TriggerNode?: undefined;
            AddSignTaskType?: undefined;
        };
        CommentInfoList: {
            CommentId: string;
            Message: {
                Text: string;
            };
            Author: string;
            Type: string;
            Time: string;
            TaskId: string;
            ProcessInstanceId: string;
        }[];
    } | {
        ProcessNode: {
            ElementType: string;
            NodeName: string;
            NodeKey: string;
            ManualUserNode: {
                NodeName: string;
                ApprovalUserType: string;
                ApprovalUserList: string[];
                ApprovalUserNameList: string[];
                ApproveMethodExtension: {
                    ApprovalMethodType: string;
                    ApprovalDatasource: {
                        Namespace: string;
                        Datasource: string;
                        DatasourceFieldList: {
                            Key: string;
                            Required: boolean;
                        }[];
                    };
                    TriggerAfterEventExtensionList: ({
                        TriggerAfterEvent: string;
                        MessageNoticeNode: {
                            MessageTypeList: number[];
                            MessageReceiverList: string[];
                            MessageTemplateId: string;
                        };
                        DatasourceExtension?: undefined;
                    } | {
                        TriggerAfterEvent: string;
                        DatasourceExtension: {
                            ExtensionElementType: string;
                            Namespace: string;
                            Datasource: string;
                            TriggerFuncList: string[];
                            UpdateFieldList: {
                                Key: string;
                                KeyType: string;
                                Value: string;
                                ValueType: string;
                            }[];
                        };
                        MessageNoticeNode?: undefined;
                    })[];
                };
                RejectMethodExtension: {
                    ApprovalMethodType: string;
                    RejectOptionType: string;
                    ApprovalDatasource: {
                        Namespace: string;
                        Datasource: string;
                        DatasourceFieldList: {
                            Key: string;
                            Required: boolean;
                        }[];
                    };
                    TriggerAfterEventExtensionList: ({
                        TriggerAfterEvent: string;
                        MessageNoticeNode: {
                            MessageTypeList: number[];
                            MessageReceiverList: string[];
                            MessageTemplateId: string;
                        };
                        DatasourceExtension?: undefined;
                    } | {
                        TriggerAfterEvent: string;
                        DatasourceExtension: {
                            ExtensionElementType: string;
                            Namespace: string;
                            Datasource: string;
                            TriggerFuncList: string[];
                            UpdateFieldList: {
                                Key: string;
                                KeyType: string;
                                Value: string;
                                ValueType: string;
                            }[];
                        };
                        MessageNoticeNode?: undefined;
                    })[];
                };
                SignTaskInfo: {
                    EnableSignTask: boolean;
                    EnableTurnSign: boolean;
                    SignTaskTypeList: string[];
                };
                ApprovalRoleIdList: any[];
                ApprovalRoleNameList: string[];
                DatasourceUserFieldList: {
                    DatasourceName: string;
                    UserFieldNameList: string[];
                    UserFieldTitleList: string[];
                }[];
                ApprovalType?: undefined;
            };
            AddSignTaskType: string;
            Status: string;
            TaskId: string;
            TriggerNode?: undefined;
        };
        CommentInfoList: {
            CommentId: string;
            Message: {
                Text: string;
            };
            Author: string;
            Type: string;
            Time: string;
            TaskId: string;
            ProcessInstanceId: string;
        }[];
    })[];
}
