export const flowData = {
    ProcessInstanceId: '776f6362-e9d0-11eb-b6fa-1ed9b82d7fca',
    ProcessDefinitionId: 'process_yumang_multi_0003',
    ProcessDefinitionName: '这是一条示例数据',
    Status: 'APPROVING',
    ProcessInstanceBeginTime: '2021-07-21T11:05:13.000+0800',
    HistoricApproveNodeCount: 5,
    SequenceFlowList: [
        {
            FlowKey: 'Node-0-1',
            FlowName: 'StartEvent-TriggerServiceTask',
            SourceNodeKey: 'Node-0',
            TargetNodeKey: 'Node-1',
        },
        {
            FlowKey: 'Node-1-2',
            FlowName: 'TriggerServiceTask-ExclusiveGateway',
            SourceNodeKey: 'Node-1',
            TargetNodeKey: 'Node-2',
        },
        {
            FlowKey: 'Node-2-3',
            FlowName: 'ExclusiveGateway-UserTask',
            SourceNodeKey: 'Node-2',
            TargetNodeKey: 'Node-3',
            DatasourceExtension: {
                ExtensionElementType: '1',
                Namespace: 'lowcode-9g57pc7ade490c12',
                Datasource: 'data-esih1bj6l8g',
                OperationOrExpressionList: [
                    {
                        OperationAndExtensionList: [
                            {
                                Key: 'approved',
                                KeyType: 'string',
                                Condition: 'eq',
                                Value: 'true',
                                ValueType: '1',
                            },
                        ],
                    },
                ],
            },
        },
        {
            FlowKey: 'Node-2-4',
            FlowName: 'ExclusiveGateway-MessageServiceTask',
            SourceNodeKey: 'Node-2',
            TargetNodeKey: 'Node-4',
            DatasourceExtension: {
                ExtensionElementType: '1',
                Namespace: 'lowcode-9g57pc7ade490c12',
                Datasource: 'data-esih1bj6l8g',
                OperationOrExpressionList: [
                    {
                        OperationAndExtensionList: [
                            {
                                Key: 'approved',
                                KeyType: 'string',
                                Condition: 'eq',
                                Value: 'false',
                                ValueType: '1',
                            },
                        ],
                    },
                ],
            },
        },
        {
            FlowKey: 'Node-4-5',
            FlowName: 'MessageServiceTask-ServiceTask',
            SourceNodeKey: 'Node-4',
            TargetNodeKey: 'Node-5',
        },
        {
            FlowKey: 'Node-3-6',
            FlowName: 'UserTask-EndEvent',
            SourceNodeKey: 'Node-3',
            TargetNodeKey: 'Node-6',
        },
        {
            FlowKey: 'Node-5-6',
            FlowName: 'ServiceTask-EndEvent',
            SourceNodeKey: 'Node-5',
            TargetNodeKey: 'Node-6',
        },
    ],
    ProcessNodeDetailList: [
        {
            ProcessNode: {
                ElementType: 'StartEvent',
                NodeName: 'StartNode0',
                NodeKey: 'Node-0',
                Status: 'APPROVE',
            },
        },
        {
            ProcessNode: {
                ElementType: 'ServiceTriggerTask',
                NodeName: 'DataTriggerNode1',
                NodeKey: 'Node-1',
                TriggerNode: {
                    RevokeTypeList: ['UNEXECUTED', 'EXECUTING'],
                    TriggerType: 'DataTrigger',
                    BeginDate: '2021-07-01',
                    EndDate: '2021-07-01',
                    ExecTime: '12:00:01',
                    TriggerCycleType: 'P1DT0S',
                    StartUser: '张三',
                    StartUserId: '1231231',
                    DatasourceExtension: {
                        ExtensionElementType: '1',
                        Namespace: 'lowcode-9g57pc7ade490c12',
                        Datasource: 'data-esih1bj6l8g',
                        TriggerFuncList: ['wedaCreate'],
                        OperationOrExpressionList: [
                            {
                                OperationAndExtensionList: [
                                    {
                                        Key: 'k10',
                                        KeyType: 'string',
                                        Condition: 'eq',
                                        Value: 'v10',
                                        ValueType: '1',
                                    },
                                    {
                                        Key: 'k11',
                                        KeyType: 'string',
                                        Condition: 'eq',
                                        Value: 'v11',
                                        ValueType: '1',
                                    },
                                ],
                            },
                            {
                                OperationAndExtensionList: [
                                    {
                                        Key: 'k20',
                                        KeyType: 'string',
                                        Condition: 'eq',
                                        Value: 'v20',
                                        ValueType: '1',
                                    },
                                    {
                                        Key: 'k21',
                                        KeyType: 'string',
                                        Condition: 'eq',
                                        Value: 'v21',
                                        ValueType: '1',
                                    },
                                ],
                            },
                        ],
                        UpdateFieldList: [],
                    },
                },
                Status: 'APPROVE',
            },
        },
        {
            ProcessNode: {
                ElementType: 'UserTask',
                NodeName: 'UserTask3',
                NodeKey: 'Node-34',
                ManualUserNode: {
                    NodeName: '一级审批',
                    ApprovalType: 'APPROVE_MULTI',
                    ApprovalUserType: 'FIX_USER',
                    ApprovalUserList: ['100'],
                    ApprovalUserNameList: ['zhangsan'],
                    ApproveMethodExtension: {
                        ApprovalMethodType: 'APPROVE',
                        ApprovalDatasource: {
                            Namespace: 'lowcode-9g57pc7ade490c12',
                            Datasource: 'data-esih1bj6l8g',
                            DatasourceFieldList: [
                                {
                                    Key: 'approveK1',
                                    Required: true,
                                },
                                {
                                    Key: 'approveK2',
                                    Required: true,
                                },
                            ],
                        },
                        TriggerAfterEventExtensionList: [
                            {
                                TriggerAfterEvent: 'NoticeEvent',
                                MessageNoticeNode: {
                                    MessageTypeList: [1, 2],
                                    MessageReceiverList: ['admin'],
                                    MessageTemplateId: '12345',
                                },
                            },
                            {
                                TriggerAfterEvent: 'TodoNoticeEvent',
                                MessageNoticeNode: {
                                    MessageTypeList: [1, 2],
                                    MessageReceiverList: ['admin'],
                                    MessageTemplateId: '12345',
                                },
                            },
                            {
                                TriggerAfterEvent: 'DatasourceEvent',
                                DatasourceExtension: {
                                    ExtensionElementType: '2',
                                    Namespace: 'lowcode-9g57pc7ade490c12',
                                    Datasource: 'data-esih1bj6l8g',
                                    TriggerFuncList: ['wedaCreate'],
                                    UpdateFieldList: [
                                        {
                                            Key: 'approveK1toKey1',
                                            KeyType: 'string',
                                            Value: 'approveK1toValue1',
                                            ValueType: '1',
                                        },
                                        {
                                            Key: 'approveK1toKey2',
                                            KeyType: 'string',
                                            Value: 'approveK1toValue2',
                                            ValueType: '1',
                                        },
                                    ],
                                },
                            },
                        ],
                    },
                    RejectMethodExtension: {
                        ApprovalMethodType: 'REJECT',
                        RejectOptionType: 'REJECT_TO_LAST_NODE',
                        ApprovalDatasource: {
                            Namespace: 'lowcode-9g57pc7ade490c12',
                            Datasource: 'data-esih1bj6l8g',
                            DatasourceFieldList: [
                                {
                                    Key: 'rejectK1',
                                    Required: true,
                                },
                                {
                                    Key: 'rejectK2',
                                    Required: true,
                                },
                            ],
                        },
                        TriggerAfterEventExtensionList: [
                            {
                                TriggerAfterEvent: 'NoticeEvent',
                                MessageNoticeNode: {
                                    MessageTypeList: [1, 2],
                                    MessageReceiverList: ['admin'],
                                    MessageTemplateId: '12345',
                                },
                            },
                            {
                                TriggerAfterEvent: 'TodoNoticeEvent',
                                MessageNoticeNode: {
                                    MessageTypeList: [1, 2],
                                    MessageReceiverList: ['admin'],
                                    MessageTemplateId: '12345',
                                },
                            },
                            {
                                TriggerAfterEvent: 'DatasourceEvent',
                                DatasourceExtension: {
                                    ExtensionElementType: '2',
                                    Namespace: 'lowcode-9g57pc7ade490c12',
                                    Datasource: 'data-esih1bj6l8g',
                                    TriggerFuncList: ['wedaCreate'],
                                    UpdateFieldList: [
                                        {
                                            Key: 'rejectKtoKey1',
                                            KeyType: 'string',
                                            Value: 'rejectKtoValue1',
                                            ValueType: '1',
                                        },
                                        {
                                            Key: 'rejectKtoKey2',
                                            KeyType: 'string',
                                            Value: 'rejectKtoValue2',
                                            ValueType: '1',
                                        },
                                    ],
                                },
                            },
                        ],
                    },
                },
                Status: 'APPROVE',
                TaskId: '',
            },
            CommentInfoList: [
                {
                    CommentId: '6e993d98-eb8b-11eb-9398-f28ff95aec33',
                    Message: {
                        Text: 'okokokoookkk',
                    },
                    Author: '100',
                    Type: 'APPROVE',
                    Time: '2021-07-23T15:56:05.345+0800',
                    TaskId: '7784c03f-e9d0-11eb-b6fa-1ed9b82d7fca',
                    ProcessInstanceId: '776f6362-e9d0-11eb-b6fa-1ed9b82d7fca',
                },
            ],
        },
        {
            ProcessNode: {
                ElementType: 'UserTask',
                NodeName: '一级审批',
                NodeKey: 'Node-35',
                ManualUserNode: {
                    NodeName: '一级审批',
                    // "ApprovalType": "APPROVE_SINGLE",
                    ApprovalUserType: 'FIX_USER',
                    ApprovalUserList: ['100'],
                    ApprovalUserNameList: ['李四'],
                    ApproveMethodExtension: {
                        ApprovalMethodType: 'APPROVE',
                        ApprovalDatasource: {
                            Namespace: 'lowcode-9g57pc7ade490c12',
                            Datasource: 'data-esih1bj6l8g',
                            DatasourceFieldList: [
                                {
                                    Key: 'approveK1',
                                    Required: true,
                                },
                                {
                                    Key: 'approveK2',
                                    Required: true,
                                },
                            ],
                        },
                        TriggerAfterEventExtensionList: [
                            {
                                TriggerAfterEvent: 'NoticeEvent',
                                MessageNoticeNode: {
                                    MessageTypeList: [1, 2],
                                    MessageReceiverList: ['admin'],
                                    MessageTemplateId: '12345',
                                },
                            },
                            {
                                TriggerAfterEvent: 'TodoNoticeEvent',
                                MessageNoticeNode: {
                                    MessageTypeList: [1, 2],
                                    MessageReceiverList: ['admin'],
                                    MessageTemplateId: '12345',
                                },
                            },
                            {
                                TriggerAfterEvent: 'DatasourceEvent',
                                DatasourceExtension: {
                                    ExtensionElementType: '2',
                                    Namespace: 'lowcode-9g57pc7ade490c12',
                                    Datasource: 'data-esih1bj6l8g',
                                    TriggerFuncList: ['wedaCreate'],
                                    UpdateFieldList: [
                                        {
                                            Key: 'approveK1toKey1',
                                            KeyType: 'string',
                                            Value: 'approveK1toValue1',
                                            ValueType: '1',
                                        },
                                        {
                                            Key: 'approveK1toKey2',
                                            KeyType: 'string',
                                            Value: 'approveK1toValue2',
                                            ValueType: '1',
                                        },
                                    ],
                                },
                            },
                        ],
                    },
                    RejectMethodExtension: {
                        ApprovalMethodType: 'REJECT',
                        RejectOptionType: 'REJECT_TO_LAST_NODE',
                        ApprovalDatasource: {
                            Namespace: 'lowcode-9g57pc7ade490c12',
                            Datasource: 'data-esih1bj6l8g',
                            DatasourceFieldList: [
                                {
                                    Key: 'rejectK1',
                                    Required: true,
                                },
                                {
                                    Key: 'rejectK2',
                                    Required: true,
                                },
                            ],
                        },
                        TriggerAfterEventExtensionList: [
                            {
                                TriggerAfterEvent: 'NoticeEvent',
                                MessageNoticeNode: {
                                    MessageTypeList: [1, 2],
                                    MessageReceiverList: ['admin'],
                                    MessageTemplateId: '12345',
                                },
                            },
                            {
                                TriggerAfterEvent: 'TodoNoticeEvent',
                                MessageNoticeNode: {
                                    MessageTypeList: [1, 2],
                                    MessageReceiverList: ['admin'],
                                    MessageTemplateId: '12345',
                                },
                            },
                            {
                                TriggerAfterEvent: 'DatasourceEvent',
                                DatasourceExtension: {
                                    ExtensionElementType: '2',
                                    Namespace: 'lowcode-9g57pc7ade490c12',
                                    Datasource: 'data-esih1bj6l8g',
                                    TriggerFuncList: ['wedaCreate'],
                                    UpdateFieldList: [
                                        {
                                            Key: 'rejectKtoKey1',
                                            KeyType: 'string',
                                            Value: 'rejectKtoValue1',
                                            ValueType: '1',
                                        },
                                        {
                                            Key: 'rejectKtoKey2',
                                            KeyType: 'string',
                                            Value: 'rejectKtoValue2',
                                            ValueType: '1',
                                        },
                                    ],
                                },
                            },
                        ],
                    },
                    SignTaskInfo: {
                        EnableSignTask: true,
                        EnableTurnSign: false,
                        SignTaskTypeList: ['FORWARD_SIGN'],
                        // SignTaskTypeList: [],
                    },
                    DatasourceUserFieldList: [
                        {
                            DatasourceName: 'beta_chb9ilr',
                            UserFieldNameList: ['owner', 'leader'],
                            UserFieldTitleList: ['负责人', '组长'],
                        },
                        {
                            DatasourceName: 'beta_chb9ilr33',
                            UserFieldNameList: ['creator'],
                            UserFieldTitleList: ['创建人'],
                        },
                    ],
                },
                Status: 'APPROVE',
                TaskId: '',
            },
            CommentInfoList: [
                {
                    CommentId: '6e993d98-eb8b-11eb-9398-f28ff95aec33',
                    Message: {
                        Text: 'okokokoookkk',
                    },
                    Author: '100',
                    Type: 'APPROVE',
                    Time: '2021-07-23T15:56:05.345+0800',
                    TaskId: '7784c03f-e9d0-11eb-b6fa-1ed9b82d7fca',
                    ProcessInstanceId: '776f6362-e9d0-11eb-b6fa-1ed9b82d7fca',
                },
            ],
        },
        {
            ProcessNode: {
                ElementType: 'UserTask',
                NodeName: '一级审批',
                NodeKey: 'Node-3',
                ManualUserNode: {
                    NodeName: '一级审批',
                    // "ApprovalType": "APPROVE_MULTI",
                    ApprovalUserType: 'FIX_USER',
                    ApprovalUserList: ['100'],
                    ApprovalUserNameList: ['王五', '李四'],
                    ApproveMethodExtension: {
                        ApprovalMethodType: 'APPROVE',
                        ApprovalDatasource: {
                            Namespace: 'lowcode-9g57pc7ade490c12',
                            Datasource: 'data-esih1bj6l8g',
                            DatasourceFieldList: [
                                {
                                    Key: 'approveK1',
                                    Required: true,
                                },
                                {
                                    Key: 'approveK2',
                                    Required: true,
                                },
                            ],
                        },
                        TriggerAfterEventExtensionList: [
                            {
                                TriggerAfterEvent: 'NoticeEvent',
                                MessageNoticeNode: {
                                    MessageTypeList: [1, 2],
                                    MessageReceiverList: ['admin'],
                                    MessageTemplateId: '12345',
                                },
                            },
                            {
                                TriggerAfterEvent: 'TodoNoticeEvent',
                                MessageNoticeNode: {
                                    MessageTypeList: [1, 2],
                                    MessageReceiverList: ['admin'],
                                    MessageTemplateId: '12345',
                                },
                            },
                            {
                                TriggerAfterEvent: 'DatasourceEvent',
                                DatasourceExtension: {
                                    ExtensionElementType: '2',
                                    Namespace: 'lowcode-9g57pc7ade490c12',
                                    Datasource: 'data-esih1bj6l8g',
                                    TriggerFuncList: ['wedaCreate'],
                                    UpdateFieldList: [
                                        {
                                            Key: 'approveK1toKey1',
                                            KeyType: 'string',
                                            Value: 'approveK1toValue1',
                                            ValueType: '1',
                                        },
                                        {
                                            Key: 'approveK1toKey2',
                                            KeyType: 'string',
                                            Value: 'approveK1toValue2',
                                            ValueType: '1',
                                        },
                                    ],
                                },
                            },
                        ],
                    },
                    RejectMethodExtension: {
                        ApprovalMethodType: 'REJECT',
                        RejectOptionType: 'REJECT_TO_LAST_NODE',
                        ApprovalDatasource: {
                            Namespace: 'lowcode-9g57pc7ade490c12',
                            Datasource: 'data-esih1bj6l8g',
                            DatasourceFieldList: [
                                {
                                    Key: 'rejectK1',
                                    Required: true,
                                },
                                {
                                    Key: 'rejectK2',
                                    Required: true,
                                },
                            ],
                        },
                        TriggerAfterEventExtensionList: [
                            {
                                TriggerAfterEvent: 'NoticeEvent',
                                MessageNoticeNode: {
                                    MessageTypeList: [1, 2],
                                    MessageReceiverList: ['admin'],
                                    MessageTemplateId: '12345',
                                },
                            },
                            {
                                TriggerAfterEvent: 'TodoNoticeEvent',
                                MessageNoticeNode: {
                                    MessageTypeList: [1, 2],
                                    MessageReceiverList: ['admin'],
                                    MessageTemplateId: '12345',
                                },
                            },
                            {
                                TriggerAfterEvent: 'DatasourceEvent',
                                DatasourceExtension: {
                                    ExtensionElementType: '2',
                                    Namespace: 'lowcode-9g57pc7ade490c12',
                                    Datasource: 'data-esih1bj6l8g',
                                    TriggerFuncList: ['wedaCreate'],
                                    UpdateFieldList: [
                                        {
                                            Key: 'rejectKtoKey1',
                                            KeyType: 'string',
                                            Value: 'rejectKtoValue1',
                                            ValueType: '1',
                                        },
                                        {
                                            Key: 'rejectKtoKey2',
                                            KeyType: 'string',
                                            Value: 'rejectKtoValue2',
                                            ValueType: '1',
                                        },
                                    ],
                                },
                            },
                        ],
                    },
                    SignTaskInfo: {
                        EnableSignTask: true,
                        EnableTurnSign: true,
                        SignTaskTypeList: ['FORWARD_SIGN'],
                    },
                    ApprovalRoleIdList: [],
                    ApprovalRoleNameList: ['管理员', '超级管理员'],
                    DatasourceUserFieldList: [
                        {
                            DatasourceName: 'beta_chb9ilr',
                            UserFieldNameList: ['owner', 'leader'],
                            UserFieldTitleList: ['负责人', '组长'],
                        },
                        {
                            DatasourceName: 'beta_chb9ilr33',
                            UserFieldNameList: ['creator'],
                            UserFieldTitleList: ['创建人'],
                        },
                    ],
                },
                AddSignTaskType: 'FORWARD_SIGN',
                Status: 'EXECUTING',
                TaskId: 'xxxxx',
            },
            CommentInfoList: [
                {
                    CommentId: '6e993d98-eb8b-11eb-9398-f28ff95aec33',
                    Message: {
                        Text: 'okokokoookkk',
                    },
                    Author: '100',
                    Type: 'APPROVE',
                    Time: '2021-07-23T15:56:05.345+0800',
                    TaskId: '7784c03f-e9d0-11eb-b6fa-1ed9b82d7fca',
                    ProcessInstanceId: '776f6362-e9d0-11eb-b6fa-1ed9b82d7fca',
                },
            ],
        },
    ],
};
