export namespace flowChartMock {
    const Status: string;
    const ProcessDefinitionName: string;
    const ProcessNodeList: ({
        Status: string;
        ElementType: string;
        NodeName: string;
        NodeKey: string;
        TriggerNode?: undefined;
        ManualUserNode?: undefined;
        BranchEnd?: undefined;
        TaskId?: undefined;
    } | {
        Status: string;
        ElementType: string;
        NodeName: string;
        TriggerNode: {
            TriggerType: string;
            DatasourceExtension: {
                Datasource: string;
                OperationOrExpressionList: {
                    OperationAndExtensionList: {
                        Condition: string;
                        KeyType: string;
                        ValueType: string;
                        Value: string;
                        Id: string;
                        Key: string;
                    }[];
                }[];
                ExtensionElementType: string;
                Namespace: string;
            };
            TriggerCycleType: string;
            StartUser: string;
            EndDate: string;
            BeginDate: string;
            ExecTime: string;
        };
        NodeKey: string;
        ManualUserNode?: undefined;
        BranchEnd?: undefined;
        TaskId?: undefined;
    } | {
        Status: string;
        ElementType: string;
        NodeName: string;
        NodeKey: string;
        ManualUserNode: {
            RejectMethodExtension: {
                ApprovalMethodType: string;
                RejectOptionType: string;
                ApprovalDatasource: {
                    Datasource: string;
                    Namespace: string;
                };
            };
            ApprovalUserNameList: string[];
            NodeName: string;
            ApprovalType: string;
            ApproveMethodExtension: {
                ApprovalMethodType: string;
                ApprovalDatasource: {
                    Datasource: string;
                    Namespace: string;
                };
            };
            ExternalData: string;
            ApprovalUserType: string;
            ApprovalUserList: string[];
            DatasourceUserFieldList?: undefined;
            ApprovalRoleNameList?: undefined;
        };
        TriggerNode?: undefined;
        BranchEnd?: undefined;
        TaskId?: undefined;
    } | {
        Status: string;
        ElementType: string;
        NodeName: string;
        NodeKey: string;
        ManualUserNode: {
            RejectMethodExtension: {
                ApprovalMethodType: string;
                RejectOptionType: string;
                ApprovalDatasource: {
                    Datasource: string;
                    Namespace: string;
                };
            };
            ApprovalUserNameList: string[];
            NodeName: string;
            ApprovalType: string;
            ApproveMethodExtension: {
                ApprovalMethodType: string;
                ApprovalDatasource: {
                    Datasource: string;
                    Namespace: string;
                };
            };
            ExternalData: string;
            ApprovalUserType: string;
            ApprovalUserList: string[];
            DatasourceUserFieldList: {
                DatasourceName: string;
                UserFieldNameList: string[];
                UserFieldTitleList: string[];
            }[];
            ApprovalRoleNameList?: undefined;
        };
        TriggerNode?: undefined;
        BranchEnd?: undefined;
        TaskId?: undefined;
    } | {
        Status: string;
        ElementType: string;
        NodeName: string;
        NodeKey: string;
        BranchEnd: string;
        TriggerNode?: undefined;
        ManualUserNode?: undefined;
        TaskId?: undefined;
    } | {
        Status: string;
        ElementType: string;
        NodeName: string;
        NodeKey: string;
        ManualUserNode: {
            RejectMethodExtension: {
                ApprovalMethodType: string;
                RejectOptionType: string;
                ApprovalDatasource: {
                    Datasource: string;
                    Namespace: string;
                };
            };
            ApprovalUserNameList: string[];
            ApprovalRoleNameList: string[];
            NodeName: string;
            ApprovalType: string;
            ApproveMethodExtension: {
                ApprovalMethodType: string;
                ApprovalDatasource: {
                    Datasource: string;
                    Namespace: string;
                };
            };
            ExternalData: string;
            ApprovalUserType: string;
            ApprovalUserList: string[];
            DatasourceUserFieldList?: undefined;
        };
        TriggerNode?: undefined;
        BranchEnd?: undefined;
        TaskId?: undefined;
    } | {
        Status: string;
        ElementType: string;
        BranchEnd: string;
        TaskId: string;
        NodeName: string;
        NodeKey: string;
        ManualUserNode: {
            RejectMethodExtension: {
                ApprovalMethodType: string;
                RejectOptionType: string;
                ApprovalDatasource: {
                    Datasource: string;
                    Namespace: string;
                };
            };
            ApprovalUserNameList: string[];
            NodeName: string;
            ApprovalType: string;
            ApproveMethodExtension: {
                ApprovalMethodType: string;
                ApprovalDatasource: {
                    Datasource: string;
                    Namespace: string;
                };
            };
            ExternalData: string;
            ApprovalUserType: string;
            ApprovalUserList: string[];
            DatasourceUserFieldList?: undefined;
            ApprovalRoleNameList?: undefined;
        };
        TriggerNode?: undefined;
    })[];
    const ProcessInstanceId: string;
    const ProcessDefinitionId: string;
    const SequenceFlowList: ({
        FlowKey: string;
        FlowName: string;
        TargetNodeKey: string;
        SourceNodeKey: string;
        DatasourceExtension?: undefined;
    } | {
        FlowKey: string;
        DatasourceExtension: {
            Datasource: string;
            OperationOrExpressionList: {
                OperationAndExtensionList: {
                    Condition: string;
                    KeyType: string;
                    ValueType: string;
                    Value: string;
                    Id: string;
                    Key: string;
                }[];
            }[];
            ExtensionElementType: string;
            Namespace: string;
            ConditionShowName: string;
        };
        FlowName: string;
        TargetNodeKey: string;
        SourceNodeKey: string;
    })[];
}
