import ApprovalHistoryEntity from '../utils/approvalHistory';
import { approvalHistoryMockData } from '../mock';
/**
 * 查询流程实例已执行节点列表详情
 * https://tcloud-dev.oa.com/document/product/1505/58890?!preview&!document=1
 *
 */
const getToastParams = (title) => ({ title, icon: 'error' });
export async function getDescribeProcessInstanceDetail(ProcessInstanceId, IS_WEDA_IDE, callWorkflow, showToast) {
    if (IS_WEDA_IDE) {
        const { historyNodeList } = new ApprovalHistoryEntity(approvalHistoryMockData);
        Promise.resolve(historyNodeList);
        return historyNodeList;
    }
    if (callWorkflow) {
        try {
            const res = await callWorkflow({
                action: 'DescribeProcessInstanceDetail',
                data: {
                    ProcessInstanceId,
                },
            });
            const { historyNodeList } = new ApprovalHistoryEntity(res);
            Promise.resolve(historyNodeList);
            return historyNodeList;
        }
        catch (error) {
            showToast(getToastParams(error === null || error === void 0 ? void 0 : error.message));
            Promise.reject(error);
            return [];
        }
    }
    else {
        const title = '没有callWorkflow方法';
        showToast(getToastParams(title));
        Promise.reject(title);
        return [];
    }
}
