export async function getDescribeGeneralOptionsDetailList(optionNames, callWedaApi, showErrorToast, isWedaIde) {
    if (isWedaIde) {
        return [];
    }
    if (callWedaApi) {
        try {
            const response = await callWedaApi({
                action: 'DescribeGeneralOptionsDetailList',
                data: {
                    OptNameList: optionNames,
                    PageIndex: 1,
                    PageSize: optionNames === null || optionNames === void 0 ? void 0 : optionNames.length,
                },
            });
            Promise.resolve(response);
            return response;
        }
        catch (error) {
            showErrorToast({ title: error.message });
            Promise.reject(error);
            return [];
        }
    }
    else {
        const title = '没有callWedaApi方法';
        showErrorToast({ title });
        return [];
    }
}
