/**
 * 根据数据源id查询流程实例信息
 * https://tcloud-dev.oa.com/document/product/1505/58830?!preview&!document=1
 * {[String]} DatasourceId [数据源Id]
 * {[String]} ItemId [数据源记录Id]
 * {[ViewId]} DatasourceId [视图Id]
 * {[EnvType]} EnvType [预览：pre；非预览：prod]
 * {[ProcessKey]} ProcessKey [流程定义Key]
 */
export function getProcessInstanceInfoByItemId({ processInstanceId, itemId, datasourceName, processKey, viewId, callWorkflow, showToast, showError, IS_WEDA_IDE, }: {
    processInstanceId: any;
    itemId: any;
    datasourceName: any;
    processKey: any;
    viewId: any;
    callWorkflow: any;
    showToast: any;
    showError: any;
    IS_WEDA_IDE: any;
}): Promise<any>;
/**
 * 审批通过
 * https://tcloud-dev.oa.com/document/product/1505/58791?!preview&!document=1
 * {[String]} TaskId [流程标识]
 * {[String]} EnvType [环境信息， pre: 预览环境，pro: 正式环境，默认为预览环境。]
 * {[Array of String	]} Variables.N	 [流程中的变量设置]
 */
export function getApprovedTask(data: any, callWorkflow: any, showToast: any): any;
/**
 * 审批驳回
 * https://tcloud-dev.oa.com/document/product/1505/58791?!preview&!document=1
 * {[String]} TaskId [流程标识]
 * {[String]} EnvType [环境信息， pre: 预览环境，pro: 正式环境，默认为预览环境。]
 * {[String	]} NodeId	 [驳回到流程中的某个节点 Id 标识]
 * {[Array of String	]} Variables.N	 [流程中的变量设置]
 */
export function getRejectedTask(data: any, callWorkflow: any, showToast: any): any;
/**
 * 审批流程撤回
 * https://tcloud-dev.oa.com/document/product/1505/58791?!preview&!document=1
 * {[String]} TaskId [流程标识]
 * {[String]} EnvType [环境信息， pre: 预览环境，pro: 正式环境，默认为预览环境。]
 * {[String	]} ProcessInstanceId	 [流程实例Id]
 * {[Array of String	]} Variables.N	 [流程中的变量设置]
 */
export function getRevokeTask(data: any, callWorkflow: any, showToast: any): any;
export function getApproversList(data: any, callWedaApi: any, showError: any, showToast: any): Promise<any>;
/**
 * 根据名称查询审批人 https://tcloud-dev.oa.com/document/product/1505/59233?!preview&!document=1
 */
export function getApproversListByName(name: any, callWedaApi: any, showError: any, showToast: any): Promise<any>;
export function getNextApprovalNodeInfo(ProcessInstanceId: any, NodeId: any, Variables: any, AddSignTaskType: any, callWorkflow: any, showError: any, showToast: any): Promise<any>;
