import { flowChartMock } from '../mock';
/**
 * 查询流程实例全流程信息
 */
export async function describeProcessInstanceNodes(data, IS_WEDA_IDE, callWorkflow, showToast) {
    if (IS_WEDA_IDE) {
        return flowChartMock;
    }
    try {
        if (callWorkflow) {
            const res = await callWorkflow({
                action: 'DescribeProcessInstanceNodes',
                data,
            });
            return res;
        }
        return null;
    }
    catch (error) {
        if (showToast) {
            showToast({
                title: '获取审批全流程失败',
                icon: 'error',
            });
        }
    }
}
