import React from 'react';
import { components } from '../../configs';
export const getConfigDefault = () => {
    const cacheJson = {};
    // eslint-disable-next-line array-callback-return
    Object.keys(components).map((item) => {
        const { properties } = components[item].data;
        const cacheComponent = {};
        // eslint-disable-next-line array-callback-return
        Object.keys(properties).map((attr) => {
            const { default: attrDefault } = properties[attr];
            if (attrDefault !== undefined && attrDefault !== '') {
                cacheComponent[attr] = attrDefault;
            }
        });
        if (Object.keys(cacheComponent).length > 0) {
            cacheJson[item] = cacheComponent;
        }
    });
    return cacheJson;
};
export const getTypeOf = (param) => {
    const cacheType = Object.prototype.toString.call(param);
    // eslint-disable-next-line prefer-destructuring
    const cacheStr = cacheType.match(/ (.+?)\]/g)[0];
    return cacheStr
        .replace(/[^a-zA-Z]/g, '')
        .toLowerCase()
        .trim();
};
export const isEmpty = (param) => {
    const paramTypeOf = getTypeOf(param);
    switch (paramTypeOf) {
        case 'string':
            return param === '';
        case 'object':
            return Object.keys(param).length === 0;
        case 'undefined':
            return true;
        case 'array':
            return param.length === 0;
        default:
            return true;
    }
};
/**
 * 用于标记是否首次修改属性
 * 是：则将默认值输入组件
 * 否：使用props值
 */
// const cacheComponent = {};
export const hoc = (Components, initDefault = {}) => (props) => {
    const cacheConfig = { ...props };
    // eslint-disable-next-line array-callback-return
    Object.keys(initDefault).map((key) => {
        if (props[key] === undefined) {
            cacheConfig[key] = initDefault[key];
        }
    });
    // cacheComponent[Components] = true;
    return React.createElement(Components, { ...cacheConfig });
};
export const setTypeDefaultValue = (key) => {
    switch (key) {
        case 'string':
            return '';
        case 'object':
            return {};
        case 'undefined':
            return undefined;
        case 'array':
            return [];
        case 'null':
            return null;
        default:
            return false;
    }
};
// 判断是否空节点
export const isSlotEmptyOrEdit = () => true;
// 获取tcb实例
export const getTcb = async () => { var _a, _b; return await ((_b = (_a = window === null || window === void 0 ? void 0 : window.app) === null || _a === void 0 ? void 0 : _a.cloud) === null || _b === void 0 ? void 0 : _b.getCloudInstance()); };
// 产生随机字符串
export const randomWord = (num) => {
    let str = '';
    const range = num;
    const arr = [
        '0',
        '1',
        '2',
        '3',
        '4',
        '5',
        '6',
        '7',
        '8',
        '9',
        'a',
        'b',
        'c',
        'd',
        'e',
        'f',
        'g',
        'h',
        'i',
        'j',
        'k',
        'l',
        'm',
        'n',
        'o',
        'p',
        'q',
        'r',
        's',
        't',
        'u',
        'v',
        'w',
        'x',
        'y',
        'z',
        'A',
        'B',
        'C',
        'D',
        'E',
        'F',
        'G',
        'H',
        'I',
        'J',
        'K',
        'L',
        'M',
        'N',
        'O',
        'P',
        'Q',
        'R',
        'S',
        'T',
        'U',
        'V',
        'W',
        'X',
        'Y',
        'Z',
    ];
    for (let i = 0; i < range; i++) {
        const pos = Math.round(Math.random() * (arr.length - 1));
        str += arr[pos];
    }
    return str;
};
export const localStorageOperating = () => ({
    getValue: (key) => {
        var _a;
        const localValue = localStorage.getItem(key);
        try {
            return (_a = JSON.parse(localValue)) === null || _a === void 0 ? void 0 : _a.value;
        }
        catch (e) {
            console.error(e);
        }
    },
    setValue: (key, value) => {
        let cacheValue = value;
        if (typeof value === 'object') {
            cacheValue = JSON.stringify({ value });
        }
        localStorage.setItem(key, cacheValue);
    },
    clear: () => localStorage.clear(),
    remove: (key) => localStorage.removeItem(key),
});
